package com.dsic.gj_erp.bean.jcsj;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.dsic.gj_erp.bean.jhgk.excel.ZrcAndPlb;
import com.dsic.gj_erp.exception.ServiceException;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * <p>
 * 
 * </p>
 *
 * @author xn
 * @since 2023-09-11
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("DM_CZPLP")
@ApiModel(value="DmCzplp对象", description="")
public class DmCzplp implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "1111")
    @TableField("DC_CH")
    private String dcCh;

    @TableField("TJRQ")
    private String tjrq;

    @TableField("BZ")
    private String bz;

    @TableField("APSZDR")
    private String apszdr;

    @TableField("YLZD6")
    private Double ylzd6;

    @TableField("YLZD3")
    private String ylzd3;

    @TableField("DC_PL_JY")
    private String dcPlJy;

    @TableField("LRR")
    private String lrr;

    @TableField("JSBS")
    private String jsbs;

    @TableField("DC_PL")
    private String dcPl;

    @TableField("YLZD1")
    private String ylzd1;

    @TableField("YLZD4")
    private Double ylzd4;

    @TableField("APSZDRQ")
    private String apszdrq;

    @TableField("DC_FD")
    private String dcFd;

    @TableField("YLZD2")
    private String ylzd2;

    @TableId(value = "ID", type = IdType.ASSIGN_UUID)
    private String id;

    @TableField("LRRQ")
    private String lrrq;

    private String scjhzt;

    private String jhyxj;

    @TableField("YLZD5")
    private Double ylzd5;

    @TableField("DC_CH_JY")
    private String dcChJy;

    @TableField("JSRQ")
    private String jsrq;

    @TableField("ZL")
    private BigDecimal zl;


    public static DmCzplp createByExcel(String dcCh,ZrcAndPlb item,String yhms){
        DmCzplp dmCzplp = new DmCzplp();
        dmCzplp.setDcCh(dcCh);
        dmCzplp.setDcFd(item.getMfd());
        try {
            dmCzplp.setZl(new BigDecimal(item.getTon()));
        }catch (Exception e){
            throw new ServiceException(10001,"吨位不是数字");
        }

        dmCzplp.setDcPl(item.getDcPl());
        dmCzplp.setLrr(yhms);
        dmCzplp.setLrrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        return dmCzplp;
    }

}
