package com.dsic.gj_erp.service.jcsj.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.*;
import com.dsic.gj_erp.bean.jcsj.vo.BomVO;
import com.dsic.gj_erp.bean.jhgk.DmTzjh;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.bean.sy.Dm_zhbmp;
import com.dsic.gj_erp.dao.sy.Dm_zhbmpRepository;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.mapper.jcsj.DmBchxmxpMapper;
import com.dsic.gj_erp.mapper.jcsj.DmBomMapper;
import com.dsic.gj_erp.mapper.jhgk.DmYdjhMapper;
import com.dsic.gj_erp.service.jcsj.*;
import com.dsic.gj_erp.service.jhgk.DmTzjhService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import com.dsic.gj_erp.service.pgd.PgdTzjhService;
import com.dsic.gj_erp.service.sy.SYService;
import com.dsic.gj_erp.util.MyFileUtil;
import com.dsic.gj_erp.util.ObjConvertUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import javax.script.ScriptException;
import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-11
 */
@Service
public class BomUploadServiceImpl {
    private static String dezt;
    @Autowired
    DmCbxxpService dmCbxxpService;
    @Autowired
    Dm_zhbmpRepository dm_zhbmpRepository;
    @Autowired
    DmBclqmxpService bclqmxpService;
    @Autowired
    DmBclqjbpService bclqjbpService;
    @Autowired
    SYService syService;
    @Autowired
    DmBchxylpService bchxylpService;
    @Autowired
    DmBchxjbpService bchxjbpService;
    @Autowired
    DmBchxmxpService bchxmxpService;
    @Autowired
    DmWlqdService wlqdService;
    @Autowired
    DmBchxmxpMapper dmBchxmxpMapper;
    @Autowired
    DmWpjbpService dmWpjbpServicel;
    @Autowired
    DmCzplpNewService dmCzplpNewService;
    @Autowired
    DmTzjhService dmTzjhService;

    @Autowired
    PgdTzjhService pgdTzjhService;
    @Autowired
    DmBomService dmBomService;
    @Autowired
    DmBomMapper bomMapper;

    @Autowired
    DmYdjhMapper dmYdjhMapper;

    @Autowired
    DmYdjhService dmYdjhService;

    @Transactional(rollbackFor = Exception.class)
    public synchronized ResultBean uploadZ(MultipartFile[] file, String czbh, String pl, String isupload, HttpServletRequest req,String path) throws IOException, CustomException, ScriptException {
        String savePath = UUID.randomUUID().toString().replace("-", "");
        //dezt="00";
        File destFile = null;
//        int del=1;
        int bcdel = 1;
        int xcdel = 1;
        int bctjdel = 1;
        int xctjdel = 1;
        int tld = 1;
        int ldpt = 1;
        String czbh1 = "";
        String pl1 = "";
            //

            List<DmBom> oloList = dmBomService.list(new QueryWrapper<DmBom>().eq("dcch", czbh)
                .eq("pl", pl)
            );
            Boolean delfag=false;
            for(DmBom e:oloList){
                if("Y".equals(e.getFkgs())){
                    delfag=true;
                    break;
                }
            }


             if (delfag) {
                throw new CustomException(10106,"不能重新导入请联系管理员");
            }





//        List<DmBom> list = dmBomService.list(new QueryWrapper<DmBom>().eq("sjch", czbh)
//            .eq(StrUtil.isNotEmpty((String) pl), "pl",pl)
//        );
//        if(list.size()>0){
//            throw new CustomException(10201, "船号"+czbh+"批量"+pl +"已经提交bom数据 不可修改");
//        }
        // 判断是否导入过
        if (isupload.equals("01")) {
            List<DmBclqjbp> bclqmxpListOld = bclqjbpService.list(new QueryWrapper<DmBclqjbp>().eq("DC_CH", czbh)
                .eq("DC_PL", pl)
            );
            if (bclqmxpListOld.size() > 0) {
                Map map = new HashMap();
                map.put("zt", "02");
                return new ResultBean(map);
            }
        } else {
        }
        File folder = new File("/"+czbh+"/"+pl);

        // Check if the directory exists
        if (folder.exists()) {
            // Delete the directory and its contents
           MyFileUtil.deleteDirectory(folder);
        }
        boolean fbom = false;
        Integer cs = null;
        System.out.println("Before sort:");
        for (MultipartFile file1 : file) {
            System.out.println(file1.getOriginalFilename());
        }
        // file 文件排序
        Arrays.sort(file, (f1, f2) -> {
            String name1 = f1.getOriginalFilename();
            String name2 = f2.getOriginalFilename();
            boolean containsKeyword1 = name1.contains("套料图") ;
            boolean containsKeyword2 = name2.contains("套料图") ;

            // 如果一个包含“套料图”，另一个不包含，则优先不包含的文件
            if (containsKeyword1 && !containsKeyword2) {
                return 1;
            } else if (!containsKeyword1 && containsKeyword2) {
                return -1;
            }

            // 如果都包含或都不包含，则按默认字母顺序排序
            return name1.compareTo(name2);
        });
        System.out.println("After sort:");
        for (MultipartFile file1 : file) {
            System.out.println(file1.getOriginalFilename());
        }
        for (MultipartFile f : file) {

            String fname = f.getOriginalFilename();
            fname = fname.substring(fname.lastIndexOf('/') + 1);
            System.out.println("fname = " + fname);
            System.out.println(f.getOriginalFilename());
            destFile = FileUtil.file(savePath, fname);
            try (InputStream inputStream = f.getInputStream()) {
                FileUtil.writeFromStream(inputStream, destFile);
            }

            List<String> lines = FileUtil.readLines(destFile, "GBK");
            lines.forEach(e -> {
                System.out.println("lines = " + e);
            });
            //  String delzt="00";
            if (fname.contains("板材领取表")) {
                int indexOfUnderscore = fname.indexOf('_');
                czbh1 = fname.substring(0, indexOfUnderscore);
                // 2. 第一个_后面批前面的字符
                int indexOfSecondUnderscore = fname.lastIndexOf('_');
                pl = fname.substring(indexOfUnderscore + 1, fname.lastIndexOf('批'));

                Map map = this.bclqbUpload(lines, fname, req, isupload, bcdel,f, path);
                bcdel++;
                if (map.get("zt").equals("02")) {
                    return new ResultBean(map);
                }
            }
            if (fname.contains("型材领取表")) {
                int indexOfUnderscore = fname.indexOf('_');
                czbh1 = fname.substring(0, indexOfUnderscore);
                // 2. 第一个_后面批前面的字符
                int indexOfSecondUnderscore = fname.lastIndexOf('_');
                pl = fname.substring(indexOfUnderscore + 1, fname.lastIndexOf('批'));
                Map map = this.xclqbUpload(lines, fname, req, isupload, xcdel,f, path);
                xcdel++;
                if (map.get("zt").equals("02")) {
                    return new ResultBean(map);
                }
            }
            if (fname.contains("板材统计数据")) {
                int indexOfUnderscore = fname.indexOf('_');
                czbh1 = fname.substring(0, indexOfUnderscore);
                // 2. 第一个_后面批前面的字符
                int indexOfSecondUnderscore = fname.lastIndexOf('_');
                pl = fname.substring(indexOfUnderscore + 1, fname.lastIndexOf('批'));
                Map map = this.bctjUpload(lines, fname, req, isupload, bctjdel,f, path);
                bctjdel++;
                if (map.get("zt").equals("02")) {
                    return new ResultBean(map);
                }
            }
            if (fname.contains("型材统计数据")) {
                int indexOfUnderscore = fname.indexOf('_');
                czbh1 = fname.substring(0, indexOfUnderscore);
                // 2. 第一个_后面批前面的字符
                int indexOfSecondUnderscore = fname.lastIndexOf('_');
                pl = fname.substring(indexOfUnderscore + 1, fname.lastIndexOf('批'));
                Map map = this.xctjUpload(lines, fname, req, isupload, xctjdel,f, path);
                xctjdel++;
                if (map.get("zt").equals("02")) {
                    return new ResultBean(map);
                }
            }
            if (fname.contains("套料图") &&  !fname.contains(".pdf")) {
                int indexOfUnderscore = fname.indexOf('_');
                czbh1 = fname.substring(0, indexOfUnderscore);
                // 2. 第一个_后面批前面的字符
                int indexOfSecondUnderscore = fname.lastIndexOf('_');
                pl = fname.substring(indexOfUnderscore + 1, fname.lastIndexOf('套'));
                Map map = this.bctltUpload(lines, fname, req, isupload, tld,f, path);
                tld++;
                if (map.get("zt").equals("02")) {
                    return new ResultBean(map);
                }
            }
            if (this.ssum(fname, '-') == 3) {
                int firstDashIndex = fname.indexOf("-");
                if (firstDashIndex != -1) {
                    // 找到第二个短划线的位置，从第一个短划线的下一个位置开始搜索
                    int secondDashIndex = fname.indexOf("-", firstDashIndex + 1);
                    if (secondDashIndex != -1) {
                        // 使用 substring 方法拆分字符串
                        czbh = fname.substring(0, secondDashIndex);
                        pl = fname.substring(secondDashIndex + 1).split("-")[0];
                    }
                }

                Map map = this.ljptbUpload(lines, fname, req, isupload, ldpt,f, path);
                ldpt++;
                if (map.get("zt").equals("02")) {
                    return new ResultBean(map);
                }
            }
//            del++;
        }

        // 修正数据
        dmYdjhMapper.xzylbs(czbh,pl);
        for (MultipartFile f : file) {
            String fname = f.getOriginalFilename();
            fname = fname.substring(fname.lastIndexOf('/') + 1);
            if (fname.contains("板材统计数据")) {
                fbom = true;
                cs = 2;
            }
            if (fname.contains("型材统计数据")) {
                fbom = true;
                cs = 2;
            }
            if (fname.contains("套料图")) {
                fbom = true;
                cs = 3;
            }
        }
        FileUtil.del(new File(savePath));
        List<BomVO> dmBoms = this.insertBom(req, czbh, pl, "01");
        if (fbom) {
            this.saveBom(req, dmBoms, czbh, pl, cs);
        }
        Map map = new HashMap();
        map.put("zt", "01");
        map.put("data", dmBoms);
        return new ResultBean(map);
    }

    /**
     * 板材领取表导入
     *
     * @param lines
     * @param fileName zt 默认传 01 如果 传02 说明二次导入  // todo （dm_czplp_new ：jsq_lqb）、《图纸计划》（dm_tzjh ：jsq_lqb）
     *                 // 根据船号 ，pi量全部删除   型材是否 插入 物品基本表
     */
    @Transactional(rollbackFor = Exception.class)
    public Map bclqbUpload(List<String> lines, String fileName, HttpServletRequest req, String zt, int bcdel,MultipartFile file,String path) throws CustomException {
        // 判断是否重复导入
        Map map = new HashMap();
        String id = syService.f_getpjh("DM", "SYSTEM", "CLDE");
        String lqlb = "";
        String onebc = lines.get(0);
        String[] splitOne = onebc.split(",");
        DmBclqjbp bclqjbp = new DmBclqjbp();
        bclqjbp.setZdr((String) req.getAttribute("yhms"));
        bclqjbp.setZdrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        bclqjbp.setDerq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        bclqjbp.setDelx("B");
        if (fileName.contains("数控")) {
            bclqjbp.setLqlb("1020");
        } else {
            bclqjbp.setLqlb("1010"); // 手工
        }
        bclqjbp.setDcCh(splitOne[0]);
        bclqjbp.setDcFd(splitOne[1]);
        bclqjbp.setDcPl(splitOne[2]);
//        DmCbxxp cbbm = dmCbxxpService.getOne(new QueryWrapper<DmCbxxp>().eq("cbbm", splitOne[0]));
//        if(cbbm.getXbz().equals("Y") && fileName.contains("跨")){
//
//        }
        // 得到第几跨   C16K-2_011批数控板材领取表(中大组立)_4跨普通板.bc      4跨普通板
        int lastUnderscoreIndex = fileName.lastIndexOf("_");
        // 找到最后一个 "." 的位置
        int lastDotIndex = fileName.lastIndexOf(".");
        if (lastUnderscoreIndex != -1 && lastDotIndex != -1 && lastDotIndex > lastUnderscoreIndex) {
            String result = fileName.substring(lastUnderscoreIndex + 1, lastDotIndex);
            Dm_zhbmp qgkw = dm_zhbmpRepository.findByBMLBAndBmsm("QGKW", result);
            if (null == qgkw) {
                throw new CustomException(10106, result + "跨位信息不存在");
            }
            bclqjbp.setZzcj(qgkw.getBM());
        } else {
            System.out.println("没有跨位信息");
        }
        bclqjbp.setYbzs(new BigDecimal(splitOne[3]));
        bclqjbp.setLqzl(new BigDecimal(splitOne[4]));
        bclqjbp.setShzl(new BigDecimal(splitOne[5]));
        bclqjbp.setYlzl(new BigDecimal(splitOne[6]));
        bclqjbp.setQpyld(new BigDecimal(splitOne[7]));
        bclqjbp.setLqbh(id);
        String mc = splitOne[8].replace("組", "组");
        Dm_zhbmp zllb = dm_zhbmpRepository.findByBMLBAndBmsm("ZLLB", mc);
        if (null == zllb) {
            throw new CustomException(10104, "请查看板材领取表组立信息");
        } else {
            bclqjbp.setDcZl(zllb.getBM());
        }
        int cs = 0;
//            List<DmBclqmxp> bclqmxpListOld = bclqmxpService.list(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", bclqjbp.getDcCh())
//                .eq("DC_ZL_z", bclqjbp.getDcZl()).eq("DC_PL_z", bclqjbp.getDcPl()).eq("DELX_z", "B")
//                .eq("LQLB_z", bclqjbp.getLqlb()).eq("ZZCJ_z", bclqjbp.getZzcj()));
        List<DmBclqmxp> bclqmxpListOld = bclqmxpService.list(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", bclqjbp.getDcCh())
            .eq("DC_PL_z", bclqjbp.getDcPl()).eq("DELX_z", "B")
        );
        if (bclqmxpListOld.size() > 0 && "01".equals(zt) && bcdel == 1) {
            // 提示是否覆盖
            map.put("zt", "02");
            return map;
        } else if ("02".equals(zt) && bcdel == 1) {
//                bclqmxpService.remove(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", bclqjbp.getDcCh())
//                        .eq("DC_ZL_z", bclqjbp.getDcZl()).eq("DC_PL_z", bclqjbp.getDcPl()).eq("DELX_z", "B")
//                        .eq("LQLB_z", bclqjbp.getLqlb()).eq("ZZCJ_z", bclqjbp.getZzcj()));
//                bclqjbpService.remove(new QueryWrapper<DmBclqjbp>().eq("DC_CH", bclqjbp.getDcCh())
//                    .eq("dc_zl", bclqjbp.getDcZl()).eq("dc_pl", bclqjbp.getDcPl()).eq("delx", "B")
//                    .eq("lqlb", bclqjbp.getLqlb()).eq("zzcj", bclqjbp.getZzcj()));
            bclqmxpService.remove(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", bclqjbp.getDcCh()).
                eq("DC_PL_z", bclqjbp.getDcPl()).eq("DELX_z", "B")
            );
            bclqjbpService.remove(new QueryWrapper<DmBclqjbp>().eq("DC_CH", bclqjbp.getDcCh())
                .eq("dc_pl", bclqjbp.getDcPl()).eq("delx", "B")
            );
            dezt = "01";
            if (bclqmxpListOld.size() <= 0) {
            } else {
                cs = null == bclqmxpListOld.get(0).getDrcs() ? 0 : bclqmxpListOld.get(0).getDrcs();
            }
            map.put("zt", "01");
        } else {
            map.put("zt", "01");
        }
        //明细部分
        int hh = Integer.valueOf(lines.get(1));
        double xh = 1;
        List<DmBclqmxp> addmx = new ArrayList<>();
        for (int i = 2; i < hh + 2; i++) {
            String bcxx = lines.get(i);
            String[] bcxxs = bcxx.split(",");
            DmBclqmxp bclqmxp = new DmBclqmxp();
            bclqmxp.setXh(new BigDecimal(xh + ""));
            bclqmxp.setWpgg(bcxxs[0]);
            bclqmxp.setSl(new BigDecimal(StringUtils.isBlank(bcxxs[1]) ? "0" : bcxxs[1]));
            bclqmxp.setWpxh(bcxxs[2]);
            bclqmxp.setLqzl(new BigDecimal(StringUtils.isBlank(bcxxs[3]) ? "0" : bcxxs[3]));
            bclqmxp.setShzl(new BigDecimal(StringUtils.isBlank(bcxxs[4]) ? "0" : bcxxs[4]));
            bclqmxp.setYlzl(new BigDecimal(StringUtils.isBlank(bcxxs[5]) ? "0" : bcxxs[5]));
            bclqmxp.setQpyld(new BigDecimal(StringUtils.isBlank(bcxxs[6]) ? "0" : bcxxs[6]));
            bclqmxp.setLjzl(new BigDecimal(StringUtils.isBlank(bcxxs[7]) ? "0" : bcxxs[7]));
            bclqmxp.setLqlbZ(bclqjbp.getLqlb());
            bclqmxp.setDcPlZ(bclqjbp.getDcPl());
            bclqmxp.setDcZlZ(bclqjbp.getDcZl());
            bclqmxp.setDcChZ(bclqjbp.getDcCh());
            bclqmxp.setDcFdZ(bclqjbp.getDcFd());
            bclqmxp.setDelxZ(bclqjbp.getDelx());
            bclqmxp.setDerqZ(bclqjbp.getDerq());
            bclqmxp.setYbzsZ(bclqjbp.getYbzs());
            bclqmxp.setLqzlZ(bclqjbp.getLqzl());
            bclqmxp.setShzlZ(bclqjbp.getShzl());
            bclqmxp.setYlzlZ(bclqjbp.getYlzl());
            bclqmxp.setQpyldZ(bclqjbp.getQpyld());
//            bclqmxp.setZxdwZ();
//            bclqmxp.setLqmjZ();
//            bclqmxp.setCjdqZ();
//            bclqmxp.setXlZ();
            bclqmxp.setZdrZ(bclqjbp.getZdr());
            bclqmxp.setZdrqZ(bclqjbp.getZdrq());
//            bclqmxp.setJsmsZ();
//            bclqmxp.setShmsZ();
            bclqmxp.setLjzlZ(bclqjbp.getLjzl());
            bclqmxp.setZzcjZ(bclqjbp.getZzcj());
            bclqmxp.setDrcs(cs + 1);
//            bclqmxp.setYlzd12();
//
//
//            bclqmxp.setYlzd9();
//            bclqmxp.setYlzd10();
//
//            bclqmxp.setYlzd7();
//
//            bclqmxp.setYlzd8();
//            bclqmxp.setSysl();
            bclqmxp.setLqbh(bclqjbp.getLqbh());
            xh++;
            addmx.add(bclqmxp);
        }
        if (addmx.size() > 0) {
            bclqmxpService.saveBatch(addmx);
        }
        addmx.forEach(e -> {
            String[] s = e.getDcFdZ().split(" ");
            for (String fd : s) {
                UpdateWrapper<DmCzplpNew> qw = new UpdateWrapper<>();
                qw.set("jsq_lqb", DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                qw.eq("dc_ch", e.getDcChZ());
                qw.eq("dc_pl", e.getDcPlZ());
                qw.eq("dc_fd", fd);
                dmCzplpNewService.update(qw);
//                UpdateWrapper<DmTzjh> qw1 = new UpdateWrapper<>();
//                qw1.set("jsq_lqb", DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
//                qw1.eq("dc_ch", e.getDcChZ());
//                qw1.eq("dc_pl", e.getDcPlZ());
//                qw1.eq("dc_fd", fd);
//                dmTzjhService.update(qw1);

                UpdateWrapper<PgdTzjh> qw1 = new UpdateWrapper<>();
                qw1.set("lqbjsrq", DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                qw1.eq("czbh", e.getDcChZ());
                qw1.eq("pl", e.getDcPlZ());
//                qw1.eq("dc_fd", fd);
                pgdTzjhService.update(qw1);


            }
        });
        bclqjbpService.save(bclqjbp);
        //上传文件到服务器
        saveFile(file,path,(String) req.getAttribute("yhms"));

        return map;
    }
    @Transactional(rollbackFor = Exception.class)
    public Map xclqbUpload(List<String> lines, String fileName, HttpServletRequest req, String zt, int xcdel,MultipartFile file,String path) throws CustomException {
        // 判断是否重复导入
        Map map = new HashMap();
        String id = syService.f_getpjh("DM", "SYSTEM", "CLDE");
        String lqlb = "";
        String onebc = lines.get(0);
        String[] splitOne = onebc.split(",");
        DmBclqjbp bclqjbp = new DmBclqjbp();
        bclqjbp.setZdr((String) req.getAttribute("yhms"));
        bclqjbp.setZdrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        bclqjbp.setDerq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        bclqjbp.setDelx("X");
        bclqjbp.setDcCh(splitOne[0]);
        bclqjbp.setDcFd(splitOne[1]);
        bclqjbp.setDcPl(splitOne[2]);
        bclqjbp.setYbzs(new BigDecimal(splitOne[3]));
        bclqjbp.setLqzl(new BigDecimal(splitOne[4]));
        bclqjbp.setShzl(new BigDecimal(splitOne[5]));
        bclqjbp.setYlzl(new BigDecimal(splitOne[6]));
        bclqjbp.setQpyld(new BigDecimal(splitOne[7]));
        bclqjbp.setLqbh(id);
        String mc = splitOne[8].replace("組", "组");
        Dm_zhbmp zllb = dm_zhbmpRepository.findByBMLBAndBmsm("ZLLB", mc);
        if (null == zllb) {
            throw new CustomException(10104, "请查看板材领取表组立信息");
        } else {
            bclqjbp.setDcZl(zllb.getBM());
        }
        bclqjbp.setJsms(new BigDecimal(splitOne[9]));
        bclqjbp.setShms(new BigDecimal(splitOne[10]));
        int cs = 0;
//        List<DmBclqmxp> bclqmxpListOld = bclqmxpService.list(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", bclqjbp.getDcCh())
//            .eq("DC_ZL_z", bclqjbp.getDcZl()).eq("DC_PL_z", bclqjbp.getDcPl()).eq("DELX_z", "X"));
        List<DmBclqmxp> bclqmxpListOld = bclqmxpService.list(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", bclqjbp.getDcCh())
            .eq("DC_PL_z", bclqjbp.getDcPl()).eq("DELX_z", "X"));
        if (bclqmxpListOld.size() > 0 && "01".equals(zt) && xcdel == 1) {
            // 提示是否覆盖
            map.put("zt", "02");
            return map;
        } else if ("02".equals(zt) && xcdel == 1) {
//            bclqmxpService.remove(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", bclqjbp.getDcCh())
//                .eq("DC_ZL_z", bclqjbp.getDcZl()).eq("DC_PL_z", bclqjbp.getDcPl()).eq("DELX_z", "X")
//            );
//            bclqjbpService.remove(new QueryWrapper<DmBclqjbp>().eq("DC_CH", bclqjbp.getDcCh())
//                .eq("dc_zl", bclqjbp.getDcZl()).eq("dc_pl", bclqjbp.getDcPl()).eq("delx", "X")
//            );
            bclqmxpService.remove(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", bclqjbp.getDcCh())
                .eq("DC_PL_z", bclqjbp.getDcPl()).eq("DELX_z", "X")
            );
            bclqjbpService.remove(new QueryWrapper<DmBclqjbp>().eq("DC_CH", bclqjbp.getDcCh())
                .eq("dc_pl", bclqjbp.getDcPl()).eq("delx", "X")
            );
            if (bclqmxpListOld.size() <= 0) {
            } else {
                cs = null == bclqmxpListOld.get(0).getDrcs() ? 0 : bclqmxpListOld.get(0).getDrcs();
            }
            map.put("zt", "01");
        } else {
            map.put("zt", "01");
        }
        //明细部分
        int hh = Integer.valueOf(lines.get(1));
        double xh = 1;
        List<DmBclqmxp> addmx = new ArrayList<>();
        for (int i = 2; i < hh + 2; i++) {
            String xcxx = lines.get(i);
            String[] xcxxs = xcxx.split(",");
            String input = xcxxs[0];
            int index = 0;
            while (index < input.length() && !Character.isDigit(input.charAt(index))) {
                index++;
            }
            String wpmc = input.substring(0, index);
            // 寻找最后一个等号的位置
            int lastEqualsIndex = input.lastIndexOf('=');
            // 获取最后一个等号后面的字符
            String wpgg = input.substring(lastEqualsIndex + 1);
            // 获取最后一个中文后面等号前面的字符
            int lastChineseIndex = 0;
            for (int ii = lastEqualsIndex - 1; ii >= 0; ii--) {
                if (Character.isLetter(input.charAt(ii))) {
                    lastChineseIndex = ii + 1;
                    break;
                }
            }
            String wpxh = input.substring(lastChineseIndex, lastEqualsIndex);
            DmBclqmxp bclqmxp = new DmBclqmxp();
            //bclqmxp
            bclqmxp.setXh(new BigDecimal(xh + ""));
            bclqmxp.setWpmc(wpmc);
            bclqmxp.setWpgg(wpgg);
            bclqmxp.setWpxh(wpxh);
            bclqmxp.setYlzd11(new BigDecimal(StringUtils.isBlank(xcxxs[1]) ? "0" : xcxxs[1]));
            bclqmxp.setSl(new BigDecimal(StringUtils.isBlank(xcxxs[2]) ? "0" : xcxxs[2]));
            bclqmxp.setLqzl(new BigDecimal(StringUtils.isBlank(xcxxs[3]) ? "0" : xcxxs[3]));
            bclqmxp.setShzl(new BigDecimal(StringUtils.isBlank(xcxxs[4]) ? "0" : xcxxs[4]));
            bclqmxp.setYlzl(new BigDecimal(StringUtils.isBlank(xcxxs[5]) ? "0" : xcxxs[5]));
            bclqmxp.setQpyld(new BigDecimal(StringUtils.isBlank(xcxxs[6]) ? "0" : xcxxs[6]));
            bclqmxp.setYlzd12(new BigDecimal(StringUtils.isBlank(xcxxs[7]) ? "0" : xcxxs[7]));
            bclqmxp.setLqms(new BigDecimal(StringUtils.isBlank(xcxxs[8]) ? "0" : xcxxs[8]));
            bclqmxp.setShms(new BigDecimal(StringUtils.isBlank(xcxxs[9]) ? "0" : xcxxs[9]));
            bclqmxp.setDcPlZ(bclqjbp.getDcPl());
            bclqmxp.setDcZlZ(bclqjbp.getDcZl());
            bclqmxp.setDcChZ(bclqjbp.getDcCh());
            bclqmxp.setDcFdZ(bclqjbp.getDcFd());
            bclqmxp.setDelxZ(bclqjbp.getDelx());
            bclqmxp.setDerqZ(bclqjbp.getDerq());
            bclqmxp.setDrcs(cs + 1);
            bclqmxp.setLqbh(bclqjbp.getLqbh());
            //////////// 主表部分
            bclqmxp.setZdrZ(bclqjbp.getZdr());
            bclqmxp.setZdrqZ(bclqjbp.getZdrq());
            bclqmxp.setDerqZ(bclqjbp.getDerq());
            bclqmxp.setDelxZ("X");
            bclqmxp.setDcChZ(bclqjbp.getDcCh());
            bclqmxp.setDcFdZ(bclqjbp.getDcFd());
            bclqmxp.setDcPlZ(bclqjbp.getDcPl());
            bclqmxp.setYbzsZ(bclqjbp.getYbzs());
            bclqmxp.setLqzlZ(bclqjbp.getLqzl());
            bclqmxp.setShzlZ(bclqjbp.getShzl());
            bclqmxp.setYlzlZ(bclqjbp.getYlzl());
            bclqmxp.setQpyldZ(bclqjbp.getQpyld());
            bclqmxp.setDcZlZ(bclqjbp.getDcZl());
            bclqmxp.setJsmsZ(bclqjbp.getJsms());
            bclqmxp.setShmsZ(bclqjbp.getShms());
            xh++;
            List<DmWpjbp> list = dmWpjbpServicel.list(new QueryWrapper<DmWpjbp>().eq("WPGG", bclqmxp.getWpxh()).eq("WPXH", bclqmxp.getWpgg()).eq("WPMC", bclqmxp.getWpmc()));
            if (list.size() <= 0) {
                List<DmWpjbp> list1 = dmWpjbpServicel.list(new QueryWrapper<DmWpjbp>().eq("WPGG", bclqmxp.getWpxh()).eq("WPXH", bclqmxp.getWpgg()));
                if (list.size() <= 0) {
                    this.insertwpjbbByxcLq(bclqmxp.getWpmc(), bclqmxp.getWpgg(), bclqmxp.getWpxh(), bclqmxp.getDcChZ(), bclqmxp.getZdrZ());
                } else {
                    bclqmxp.setWph(list1.get(0).getWph());
                }
            } else {
                bclqmxp.setWph(list.get(0).getWph());
            }
            addmx.add(bclqmxp);
        }
        if (addmx.size() > 0) {
            bclqmxpService.saveBatch(addmx);
        }
        bclqjbpService.save(bclqjbp);
        //上传文件到服务器
        saveFile(file,path,(String) req.getAttribute("yhms"));
        return map;
        // 判断 INSERT INTO DM_WPJBP(WPH,WPMC,WPFLM,WPXH,WPGG,DC_CH,ZDRY,XGSJ,WPJB,GZLX,JLDW,JLDW1 )
        //		VALUES (:ls_wpbm,:as_wpmc,:as_wpfl,:as_wpxh,:as_wpgg,:as_dc_ch,:gs_user,:gs_xtrq,'Y','M',:ls_jldw,'19')  ;
    }

    //C16K-2_011批量手工板材统计数据_3跨.BC
    @Transactional(rollbackFor = Exception.class)
    public Map bctjUpload(List<String> lines, String fileName, HttpServletRequest req, String zt, int bctjdel,MultipartFile file,String path) throws CustomException {
        Map map = new HashMap();
        List<DmBchxylp> adds = new ArrayList<>();
        int indexOfUnderscore = fileName.indexOf('_');
        String czbh = fileName.substring(0, indexOfUnderscore);
//        List<Dm_zhbmp> zllbs = dm_zhbmpRepository.findByBMLB("ZLLB");
//        Map<String, String> zllbMap = zllbs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        List<Dm_zhbmp> zllbs = dm_zhbmpRepository.findByBMLB("ZLLB");
        List<Dm_zhbmp> kwxxs = dm_zhbmpRepository.findByBMLB("KWXX");
        List<Dm_zhbmp> qgkws = dm_zhbmpRepository.findByBMLB("QGKW");
        Map<String, String> zllbMap = zllbs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        Map<String, String> kwxxMap = kwxxs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> qgKwMap = qgkws.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        // 2. 第一个_后面批前面的字符
        int indexOfSecondUnderscore = fileName.lastIndexOf('_');
        String pl = fileName.substring(indexOfUnderscore + 1, fileName.lastIndexOf('批'));
        String kw;
        // 3. 最后一个_后面.前面的字符
        if (fileName.contains("跨")) {
            int indexOfDot = fileName.lastIndexOf('跨');
            kw = fileName.substring(indexOfSecondUnderscore + 1, indexOfDot);
        } else if (fileName.contains("光电")) {
            kw = "光电";
        } else {
            throw new CustomException(10106, fileName + "跨位信息不存在");
        }
        DmCbxxp cbbm = dmCbxxpService.getOne(new QueryWrapper<DmCbxxp>().select("isnull(xbz,'N') AS  xbz").eq("cbbm", czbh));
        String ls_jgdm = "";
        if (cbbm.getXbz().equals("Y")) {
            if (fileName.contains("数控")) {
                ls_jgdm = "1020";
            }
            if (fileName.contains("手工")) {
                ls_jgdm = "1010";
            }
        }
        int cs = 0;
        //select count(*) into:li_zl from dm_bchxylp where dc_ch =:dc_ch and dc_pl =:dc_pl and zzcj =:ls_zzcj and hxfl ='B' and tzbh = :ls_import[1];
        List<DmBchxylp> tjListOld = bchxylpService.list(new QueryWrapper<DmBchxylp>().eq("dc_ch", czbh).eq("dc_pl", pl).eq("hxfl", "B"));
        if (tjListOld.size() > 0 && "01".equals(zt) && bctjdel == 1) {
            // 提示是否覆盖
            map.put("zt", "02");
            return map;
        } else if ("02".equals(zt) && bctjdel == 1) {
            bchxylpService.remove(new QueryWrapper<DmBchxylp>().eq("dc_ch", czbh).eq("dc_pl", pl).eq("hxfl", "B"));
            if (tjListOld.size() <= 0) {
            } else {
                cs = null == tjListOld.get(0).getDrcs() ? 0 : tjListOld.get(0).getDrcs();
            }
            map.put("zt", "01");
        } else {
            map.put("zt", "01");
        }
        for (String line : lines) {
            String[] splitLine = line.split(",");
            // 得到 余料数量
            int ylsl = Integer.valueOf(splitLine[5]);
            if (0 == ylsl) {
                DmBchxylp bchxylp = new DmBchxylp();
                String id = syService.f_getpjh("DM", "SYSTEM", "YLBH");
                bchxylp.setDcCh(czbh);
                bchxylp.setDcPl(pl);
                bchxylp.setHxbh(id);
                bchxylp.setXh(1d);
                bchxylp.setTzbh(splitLine[0]);
                bchxylp.setSfyl(splitLine[1]);
                bchxylp.setDcZl(zllbMap.get(splitLine[2]));
                String[] ggAndsl = splitLine[3].split("=");
                bchxylp.setWpgg(ggAndsl[0]);
                bchxylp.setSl(new BigDecimal(ggAndsl[1]));
                bchxylp.setWpxh(splitLine[4]);
                bchxylp.setHxfl("B");
                bchxylp.setZdr((String) req.getAttribute("yhms"));
                bchxylp.setZdrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                if (cbbm.getXbz().equals("N")) {
                    if ("N".equals(splitLine[0].substring(0, 1))) {
                        ls_jgdm = "1010";
                    } else {
                        ls_jgdm = "1020";
                    }
                }
                bchxylp.setYlzd1(ls_jgdm);
                bchxylp.setZzcj(kw);
                bchxylp.setDrcs(cs + 1);
                String tzbh = splitLine[0];
                String hxlx = "";
                if (tzbh.substring(4, 5).equals("S")) {
                    hxlx = "1010";
                } else if (tzbh.substring(4, 5).equals("N")) {
                    hxlx = "1020";
                }
                // 跨位
                String s = kwxxMap.get(tzbh.substring(4, 7));
                if (StringUtils.isBlank(s)) {
                    throw new CustomException(10106, fileName + "跨位信息不存在");
                }
                String zl = this.getZL(tzbh);
                if (StringUtils.isBlank(zl)) {
                    throw new CustomException(10106, fileName + "组立信息不存在");
                }
                String zlbm = zllbMap.get(zl);
                String zzcj = qgKwMap.get(s);  //xhj
                bchxylp.setYlzd1(hxlx);
                bchxylp.setZzcj(zzcj);
                bchxylp.setDcZl(zlbm);
                adds.add(bchxylp);
            } else {
                String ylggs = "";
                for (int iiy = 1; iiy <= ylsl; iiy++) {
                    if (iiy == ylsl) {
                        ylggs = ylggs + splitLine[0].substring(1) + "S_" + iiy + "(" + splitLine[5 + iiy] + ")";
                    } else {
                        ylggs = ylggs + splitLine[0].substring(1) + "S_" + iiy + "(" + splitLine[5 + iiy] + "),";
                    }
                }
                for (int i = 1; i <= ylsl; i++) {
                    DmBchxylp bchxylp = new DmBchxylp();
                    String id = syService.f_getpjh("DM", "SYSTEM", "YLBH");
                    bchxylp.setDcCh(czbh);
                    bchxylp.setDcPl(pl);
                    bchxylp.setHxbh(id);
                    bchxylp.setXh(Double.valueOf(i));
                    bchxylp.setTzbh(splitLine[0]);
                    bchxylp.setSfyl(splitLine[1]);
                    bchxylp.setDcZl(zllbMap.get(splitLine[2]));
                    String[] ggAndsl = splitLine[3].split("=");
                    bchxylp.setWpgg(ggAndsl[0]);
                    bchxylp.setSl(new BigDecimal(ggAndsl[1]));
                    bchxylp.setWpxh(splitLine[4]);
                    bchxylp.setHxfl("B");
                    bchxylp.setZdr((String) req.getAttribute("yhms"));
                    bchxylp.setZdrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                    if (cbbm.getXbz().equals("N")) {
                        if ("N".equals(splitLine[0].substring(0, 1))) {
                            ls_jgdm = "1010";
                        } else {
                            ls_jgdm = "1020";
                        }
                    }
                    bchxylp.setYlzd1(ls_jgdm);
                    bchxylp.setZzcj(kw);
                    bchxylp.setDrcs(cs + 1);
                    bchxylp.setYlbh(splitLine[0].substring(1) + "S_" + i);
                    bchxylp.setYlgg(splitLine[5 + i]);
                    bchxylp.setYlggs(ylggs);
                    String tzbh = splitLine[0];
                    String hxlx = "";
                    if (tzbh.substring(4, 5).equals("S")) {
                        hxlx = "1010";
                    } else if (tzbh.substring(4, 5).equals("N")) {
                        hxlx = "1020";
                    }
                    // 跨位
                    String s = kwxxMap.get(tzbh.substring(4, 7));
                    if (StringUtils.isBlank(s)) {
                        throw new CustomException(10106, fileName + "跨位信息不存在");
                    }
                    String zl = this.getZL(tzbh);
                    if (StringUtils.isBlank(zl)) {
                        throw new CustomException(10106, fileName + "组立信息不存在");
                    }
                    String zlbm = zllbMap.get(zl);
                    String zzcj = qgKwMap.get(s); //xhj
                    bchxylp.setYlzd1(hxlx);
                    bchxylp.setZzcj(zzcj);
                    bchxylp.setDcZl(zlbm);
                    adds.add(bchxylp);
                }
            }
        }
        if (adds.size() > 0) {
            bchxylpService.saveBatch(adds);
            //上传文件到服务器
            saveFile(file,path,(String) req.getAttribute("yhms"));
        }
        return map;
    }

    @Transactional(rollbackFor = Exception.class)
    public Map xctjUpload(List<String> lines, String fileName, HttpServletRequest req, String zt, int xctjdel,MultipartFile file,String path) throws CustomException {
        Map map = new HashMap();
        List<Dm_zhbmp> zllbs = dm_zhbmpRepository.findByBMLB("ZLLB");
        List<Dm_zhbmp> kwxxs = dm_zhbmpRepository.findByBMLB("KWXX");
        List<Dm_zhbmp> qgkws = dm_zhbmpRepository.findByBMLB("QGKW");
        Map<String, String> zllbMap = zllbs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        Map<String, String> kwxxMap = kwxxs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> qgKwMap = qgkws.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        List<DmBchxylp> adds = new ArrayList<>();
//        List<Dm_zhbmp> zllbs = dm_zhbmpRepository.findByBMLB("ZLLB");
//        Map<String, String> zllbMap = zllbs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        int indexOfUnderscore = fileName.indexOf('_');
        String czbh = fileName.substring(0, indexOfUnderscore);
        // 2. 第一个_后面批前面的字符
        int indexOfSecondUnderscore = fileName.lastIndexOf('_');
        String pl = fileName.substring(indexOfUnderscore + 1, fileName.lastIndexOf('批'));
        String kw;
        // 3. 最后一个_后面.前面的字符
        if (fileName.contains("跨")) {
            int indexOfDot = fileName.lastIndexOf('跨');
            kw = fileName.substring(indexOfSecondUnderscore + 1, indexOfDot);
        } else if (fileName.contains("光电")) {
            kw = "光电";
        } else {
            throw new CustomException(10106, fileName + "跨位信息不存在");
        }
        int cs = 0;
        //select count(*) into:li_zl from dm_bchxylp where dc_ch =:dc_ch and dc_pl =:dc_pl and zzcj =:ls_zzcj and hxfl ='B' and tzbh = :ls_import[1];
        List<DmBchxylp> tjListOld = bchxylpService.list(new QueryWrapper<DmBchxylp>().eq("dc_ch", czbh).eq("dc_pl", pl).eq("hxfl", "X"));
        if (tjListOld.size() > 0 && "01".equals(zt) && xctjdel == 1) {
            // 提示是否覆盖
            map.put("zt", "02");
            return map;
        } else if ("02".equals(zt) && xctjdel == 1) {
            bchxylpService.remove(new QueryWrapper<DmBchxylp>().eq("dc_ch", czbh).eq("dc_pl", pl).eq("hxfl", "X"));
            if (tjListOld.size() <= 0) {
            } else {
                cs = null == tjListOld.get(0).getDrcs() ? 0 : tjListOld.get(0).getDrcs();
            }
            map.put("zt", "01");
            dezt = "01";
        } else {
            map.put("zt", "01");
        }
        int ii = 1;
        for (String line : lines) {
            String[] splitLine = line.split(",");
            String id = syService.f_getpjh("DM", "SYSTEM", "YLBH");
            String[] wps = splitLine[3].split("=");
            String cz = wps[1];
            String cd = wps[0].split("-")[1];
            String input = wps[0].split("-")[0];
            int index = 0;
            while (index < input.length() && !Character.isDigit(input.charAt(index))) {
                index++;
            }
            String wpmc = input.substring(0, index);
            // 寻找最后一个等号的位置
            // 获取最后一个等号后面的字符
            String wpgg = input.substring(wpmc.length());
            DmBchxylp bchxylp = new DmBchxylp();
            bchxylp.setDcCh(czbh);
            bchxylp.setDcPl(pl);
            bchxylp.setHxbh(id);
            bchxylp.setXh(Double.valueOf(ii));
            bchxylp.setTzbh(splitLine[0]);
            bchxylp.setSfyl(splitLine[1]);
            bchxylp.setDcZl(zllbMap.get(splitLine[2]));
            bchxylp.setWpgg(wpgg);
            bchxylp.setWpxh(cz);
            bchxylp.setXcmc(wpmc);
            bchxylp.setXccd(new BigDecimal(cd));
            bchxylp.setSl(new BigDecimal(splitLine[4]));
            if (splitLine.length > 5) {
                bchxylp.setYlcd(new BigDecimal(StringUtils.isBlank(splitLine[5]) ? "0" : splitLine[5]));
            }
            bchxylp.setHxfl("X");
            bchxylp.setZdr((String) req.getAttribute("yhms"));
            bchxylp.setZdrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            bchxylp.setDrcs(cs + 1);
            ii++;
            String tzbh = splitLine[0];
            String hxlx = "";
            if (tzbh.substring(4, 5).equals("S")) {
                hxlx = "1010";
            } else if (tzbh.substring(4, 5).equals("N")) {
                hxlx = "1020";
            }
            // 跨位
            String s = kwxxMap.get(tzbh.substring(4, 7));
            if (StringUtils.isBlank(s)) {
                throw new CustomException(10106, fileName + "跨位信息不存在");
            }
            String zl = this.getZL(tzbh);
            if (StringUtils.isBlank(zl)) {
                throw new CustomException(10106, fileName + "组立信息不存在");
            }
            String zlbm = zllbMap.get(zl);
            String zzcj = qgKwMap.get(s); //xhj
            bchxylp.setZzcj(zzcj);
            bchxylp.setDcZl(zlbm);
            adds.add(bchxylp);
        }
        if (adds.size() > 0) {
            bchxylpService.saveBatch(adds);
            //上传文件到服务器
            saveFile(file,path,(String) req.getAttribute("yhms"));
        }
        return map;
    }
    @Transactional(rollbackFor = Exception.class)
    public Map bctltUpload(List<String> lines, String fileName, HttpServletRequest req, String zt, int tld,MultipartFile file,String path) throws CustomException, ScriptException {
        Map map = new HashMap();
        List<DmBchxjbp> adds = new ArrayList<>();
        List<DmBchxmxp> addmxs = new ArrayList<>();
        int indexOfUnderscore = fileName.indexOf('_');
        String czbh = fileName.substring(0, indexOfUnderscore);
        // 2. 第一个_后面批前面的字符
        int indexOfSecondUnderscore = fileName.lastIndexOf('_');
        String pl = fileName.substring(indexOfUnderscore + 1, fileName.lastIndexOf('套'));
        List<DmBchxmxp> tltListOld = bchxmxpService.list(new QueryWrapper<DmBchxmxp>().eq("DC_CH_z", czbh).eq("dc_pl_z", pl));
        List<Dm_zhbmp> zllbs = dm_zhbmpRepository.findByBMLB("ZLLB");
        List<Dm_zhbmp> kwxxs = dm_zhbmpRepository.findByBMLB("KWXX");
        List<Dm_zhbmp> qgkws = dm_zhbmpRepository.findByBMLB("QGKW");
        Map<String, String> zllbMap = zllbs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        Map<String, String> kwxxMap = kwxxs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> qgKwMap = qgkws.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        int cs = 0;
        if (tltListOld.size() > 0 && "01".equals(zt) && tld == 1) {
            // 提示是否覆盖
            map.put("zt", "02");
            return map;
        } else if ("02".equals(zt) && tld == 1) {
            bchxmxpService.remove(new QueryWrapper<DmBchxmxp>().eq("DC_CH_z", czbh).eq("dc_pl_z", pl));
            bchxjbpService.remove(new QueryWrapper<DmBchxjbp>().eq("dc_ch", czbh).eq("dc_pl", pl));
            if (tltListOld.size() <= 0) {
            } else {
                cs = null == tltListOld.get(0).getDrcs() ? 0 : tltListOld.get(0).getDrcs();
            }
            map.put("zt", "01");
        } else {
            map.put("zt", "01");
        }
        for (int j = 0; j <= lines.size(); ) {
            if (StringUtils.isBlank(lines.get(j))) {
                break;
            }
            String[] tltLine = lines.get(j).split(",");
            // todo 没有判断 调料图是否重复
            int ll_ii = 0;
            int ggsl = Integer.valueOf(tltLine[1].split("=")[1]);
            String tzbh = tltLine[0];
            String hxlx = "";
            if (tzbh.substring(0, 1).equals("S")) {
                hxlx = "1010";
            } else if (tzbh.substring(0, 1).equals("N")) {
                hxlx = "1020";
            }
            // 根据图纸编号获取 手工，数控 跨位，组立，、
            if (tzbh.substring(4, 5).equals("S")) {
                hxlx = "1010";
            } else if (tzbh.substring(4, 5).equals("N")) {
                hxlx = "1020";
            }
            // 跨位
            String s = kwxxMap.get(tzbh.substring(4, 7));

            if (StringUtils.isBlank(s)) {
                throw new CustomException(10106, fileName + "跨位信息不存在");
            }
            String zl = this.getZL(tzbh);
            if (StringUtils.isBlank(zl)) {
                throw new CustomException(10106, fileName + "组立信息不存在");
            }
            String zlbm = zllbMap.get(zl);
            String zzcj = qgKwMap.get(s); //xhj
            for (int i = 1; i <= ggsl; i++) {
                DmBchxjbp bchxjbp = new DmBchxjbp();
                String id = syService.f_getpjh("DM", "SYSTEM", "BCHX");
                bchxjbp.setHxbh(id);
                bchxjbp.setDcCh(czbh);
                bchxjbp.setDcPl(pl);
                bchxjbp.setDcZl(zlbm);
                bchxjbp.setYlzd1(hxlx);
                if (i == 1 || ggsl == 1) {
                    bchxjbp.setTzbh(tzbh);
                } else if (i > 1) {
                    ll_ii++;
                    bchxjbp.setTzbh(tzbh + ll_ii);
                }
                if (tzbh.substring(4, 5).equals("X")) {
                    //todo
//                    li_nu = 0
//                    li_number = 0
//                    do while li_nu = 0
//                    li_number++
//                    ls_number = mid(ls_gg,li_number,1)
//                    if isnumber(ls_number) = true then
//                        //得到名称
//                        ls_clmc = mid(ls_gg,1,li_number - 1)
//                    //得到规格
//                    ls_gg = mid(ls_gg,li_number)
//                    li_nu = 1
//                    end if
//                    loop
//                    win_k.dw_master.setitem(li_get,'clmc',ls_clmc)
//
//                    win_k.dw_master.setitem(li_get,'ljsl',dec(ls_import[4]))
                    bchxjbp.setHxfl("X");
                    bchxjbp.setLjsl(new BigDecimal(tltLine[3]));
                } else {
                    if (tltLine.length >= 6) {
                        bchxjbp.setYlzd4(new BigDecimal(tltLine[3]));
                        bchxjbp.setHxcd(new BigDecimal(tltLine[4]));
                        bchxjbp.setLjsl(new BigDecimal(tltLine[5]));
                        bchxjbp.setHxfl("B");
                    }
                }
                String gg = "";
                if (tltLine[1].contains("=")) {
                    String[] ggtemp = tltLine[1].split("=");
                    if (ggtemp[0].contains("-")) {
                        String[] ggtemp1 = ggtemp[0].split("-");
                        gg = ggtemp1[0];
                        gg = gg.replaceAll("[\\u4e00-\\u9fa5]", "");
                    } else {
                        gg = ggtemp[0];
                    }
                }
                if (gg.matches("[0-9.*]*")) {
                    bchxjbp.setWpgg(gg.replaceAll("\\.0", ""));
                }
                ;
                bchxjbp.setWpxh(tltLine[2]);
                bchxjbp.setZdr((String) req.getAttribute("yhms"));
                bchxjbp.setZdrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                bchxjbp.setXtrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                bchxjbp.setYlzd2("1");
                adds.add(bchxjbp);
                // 获取零件数量
                int ljsl; // 第0行
                if (tltLine.length >= 6) {
                    ljsl = Integer.valueOf(tltLine[5]);
                } else {
                    ljsl = Integer.valueOf(tltLine[3]);
                }
                List ljmcs = new ArrayList();
                for (int lji = 1; lji <= ljsl; lji++) {
                    DmBchxmxp bchxmxp = new DmBchxmxp();
                    bchxmxp.setHxbh(id);
                    bchxmxp.setXh(Double.valueOf(lji));
                    // String hh = lines.get(j + lji); // 零件的坐标
                    String ljmc = lines.get(j + lji);
                    BigDecimal sl = new BigDecimal("1");
                    if (lines.get(j + lji).contains(",")) {
                        ljmc = lines.get(j + lji).split(",")[0];
                        System.out.println("ljmc = " + ljmc);
                        System.out.println("ljmc = " + lines.get(j + lji).split(",")[1]);
                        sl = new BigDecimal(String.valueOf(lines.get(j + lji).split(",")[1].trim()));
                    }
                    if (ljmcs.contains(ljmc)) {
                    } else {
                        ljmcs.add(ljmc);
                        bchxmxp.setWph(ljmc);
                        bchxmxp.setSl(sl);
                        //----------------------
                        bchxmxp.setDcChZ(bchxjbp.getDcCh());
                        bchxmxp.setDcPlZ(bchxjbp.getDcPl());
                        bchxmxp.setYlzd1Z(bchxjbp.getYlzd1());
                        bchxmxp.setTzbhZ(bchxjbp.getTzbh());
                        bchxmxp.setYlzd4Z(bchxjbp.getYlzd4());
                        bchxmxp.setHxcdZ(bchxjbp.getHxcd());
                        bchxmxp.setLjslZ(bchxjbp.getLjsl());
                        bchxmxp.setHxflZ(bchxjbp.getHxfl());
                        bchxmxp.setWpggZ(bchxjbp.getWpgg());
                        bchxmxp.setWpxhZ(bchxjbp.getWpxh());
                        bchxmxp.setZdrZ(bchxjbp.getZdr());
                        bchxmxp.setZdrqZ(bchxjbp.getZdrq());
                        bchxmxp.setYlzd2Z(bchxjbp.getYlzd2());
                        bchxmxp.setZzcj(zzcj);
                        bchxmxp.setDcFdZ(StringUtils.isBlank(bchxmxp.getWph()) ? "" : bchxmxp.getWph().substring(0, 4));
                        bchxmxp.setDcZlZ(zl);
                        bchxmxp.setDrcs(cs + 1);
                        addmxs.add(bchxmxp);
                    }
                }
                j = j + ljsl + 1;
            }
        }
        if (addmxs.size() > 0) {
            bchxmxpService.saveBatch(addmxs);
            bchxjbpService.saveBatch(adds);
            //List<DmBchxjbp> dmBchxjbps,Map kwxxMap,Map qgKwMap , HttpServletRequest req
            Map bomxzjh = bomxzjh(adds, kwxxMap, qgKwMap, req,addmxs);
            List<DmYdjh> adds1 = (List<DmYdjh>) bomxzjh.get("adds");
            List<DmYdjh> ups = (List<DmYdjh>) bomxzjh.get("ups");
            List<DmYdjh> yds = (List<DmYdjh>) bomxzjh.get("ydjhs");
           String delid = (String) bomxzjh.get("deyd");
        if(yds.size()>0){
            for(DmYdjh dmYdjh:yds){
                DmYdjh dmYdjh1 =new DmYdjh();
                dmYdjh1.setZt("99");
                dmYdjh1.setId(dmYdjh.getId());
                dmYdjhService.updateById(dmYdjh1);
            }
        }

            dmYdjhService.saveBatch(adds1);
            dmYdjhService.updateBatchById(ups);
            // 修正 生产计划。
            DmYdjh delyd=new DmYdjh();
            delyd.setZt("-1");
            delyd.setId(delid);
            dmYdjhService.updateById(delyd);
            dmBchxmxpMapper.updateWpgg(czbh, pl);
            dmBchxmxpMapper.updateWph(czbh, pl);
            //上传文件到服务器
            saveFile(file,path,(String) req.getAttribute("yhms"));
        }
        // 反写批量表 零件编号 前4位是分段号
        addmxs.forEach(e -> {
            UpdateWrapper<DmCzplpNew> qw = new UpdateWrapper<>();
            qw.set("jsq_tlt", DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            qw.eq("dc_ch", e.getDcChZ());
            qw.eq("dc_pl", e.getDcPlZ());
            qw.eq("dc_fd", StringUtils.isBlank(e.getWph()) ? "" : e.getWph().substring(0, 4));
            dmCzplpNewService.update(qw);
//            UpdateWrapper<DmTzjh> qw1 = new UpdateWrapper<>();
//            qw1.set("jsq_tlt", DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
//            qw1.eq("dc_ch", e.getDcChZ());
//            qw1.eq("dc_pl", e.getDcPlZ());
//            qw1.eq("dc_fd", StringUtils.isBlank(e.getWph()) ? "" : e.getWph().substring(0, 4));
//            dmTzjhService.update(qw1);


            UpdateWrapper<PgdTzjh> qw1 = new UpdateWrapper<>();
            qw1.set("tltjsrq", DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            qw1.eq("czbh", e.getDcChZ());
            qw1.eq("pl", e.getDcPlZ());
//                qw1.eq("dc_fd", fd);
            pgdTzjhService.update(qw1);
        });
        return map;
    }
    @Transactional(rollbackFor = Exception.class)
    public Map ljptbUpload(List<String> lines, String fileName, HttpServletRequest req, String zt, int ldpt,MultipartFile file,String path) throws CustomException {
        List<DmWlqd> adds = new ArrayList<>();
        Map map = new HashMap();
        String czbh = "";
        String pl = "";
        String fd = "";
        int firstDashIndex = fileName.indexOf("-");
        if (firstDashIndex != -1) {
            // 找到第二个短划线的位置，从第一个短划线的下一个位置开始搜索
            int secondDashIndex = fileName.indexOf("-", firstDashIndex + 1);
            if (secondDashIndex != -1) {
                // 使用 substring 方法拆分字符串
                czbh = fileName.substring(0, secondDashIndex);
                pl = fileName.substring(secondDashIndex + 1).split("-")[0];
                fd = fileName.substring(0, fileName.indexOf(".", firstDashIndex + 1)).substring(secondDashIndex + 1).split("-")[1];
                System.out.println("第一部分：" + czbh);
                System.out.println("第二部分：" + pl);
            }
        } else {
            throw new CustomException(10104, "文件名格式错误！");
        }
        List<DmWlqd> wlqdListOld = wlqdService.list(new QueryWrapper<DmWlqd>().eq("dc_ch", czbh).eq("dc_pl", pl));
        int cs = 0;
        if (wlqdListOld.size() > 0 && "01".equals(zt) && 1 == ldpt) {
            // 提示是否覆盖
            map.put("zt", "02");
            return map;
        } else if ("02".equals(zt) && 1 == ldpt) {
            wlqdService.remove(new QueryWrapper<DmWlqd>().eq("dc_ch", czbh).eq("dc_pl", pl));
            if (wlqdListOld.size() <= 0) {
            } else {
                cs = null == wlqdListOld.get(0).getDrcs() ? 0 : wlqdListOld.get(0).getDrcs();
            }
            map.put("zt", "01");
        } else {
            map.put("zt", "01");
        }
        List<Dm_zhbmp> sjlxs = dm_zhbmpRepository.findByBMLB("SJLX");
        Map<String, String> sjlxMap = sjlxs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        wlqdService.remove(new QueryWrapper<DmWlqd>().eq("dc_ch", czbh).eq("dc_fd", fd));
        List<Dm_zhbmp> zllbs = null;
        zllbs = dm_zhbmpRepository.findByBMLB("ZLLB");
        System.out.println("zllbs = " + zllbs);
        Map<String, String> zllbMap1 = zllbs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
//        Map<String, String> zllbMap = zllbs.stream().collect(
//
//            Collectors.toMap(
//                Dm_zhbmp::getBmsm,
//                Dm_zhbmp::getBM
//
//            )
//
//        );
        int xh = 1;
        for (String ljline : lines) {
            String[] ljlines = ljline.split(",");
            String pt = ljlines[9].replaceAll("[()]", "");
            String jldw = "";
            String wpfl = "";
            if ("型材".equals(pt)) {
                jldw = "60";
                wpfl = "X";
            } else {
                jldw = "51";
                wpfl = "B";
            }
            DmWlqd wlqd = new DmWlqd();
            wlqd.setXwh(Double.valueOf(xh));
            wlqd.setFxwph(czbh + "=" + fd);
            wlqd.setYlzd1(sjlxMap.get(pt));
            wlqd.setZxwph(ljlines[0].trim());
            wlqd.setWph(ljlines[0].trim());
            wlqd.setWpmc(ljlines[1].trim());
            wlqd.setWpgg(ljlines[2].trim());
            wlqd.setWpxh(ljlines[4].trim());
            wlqd.setJldw(jldw);
            wlqd.setSl(new BigDecimal(StringUtils.isBlank(ljlines[3]) ? "0" : ljlines[3]));
            wlqd.setWpflm(wpfl);
            wlqd.setDezl(new BigDecimal(StringUtils.isBlank(ljlines[10]) ? "0" : ljlines[10]));
            wlqd.setWpjb("L");
            wlqd.setGylb("0");
            wlqd.setGysbh(ljlines[0].trim());
            wlqd.setDcCh(czbh);
            wlqd.setDcCm(czbh);
            wlqd.setDcFd(fd);
            wlqd.setDcPl(pl);
            wlqd.setDcTz(ljlines[5].trim());
            wlqd.setDcYj(ljlines[6].trim());
            wlqd.setDcYs(ljlines[7].trim());
            wlqd.setZdry((String) req.getAttribute("yhms"));
            wlqd.setXgrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            wlqd.setDrcs(cs + 1);
            wlqd.setZt("0");
            String mc = ljlines[8].replace("組", "组");
            //Dm_zhbmp zllb = dm_zhbmpRepository.findByBMLBAndBmsm("ZLLB", mc.trim());
            String zllb = zllbMap1.get(mc.trim());//
            if (StringUtils.isBlank(zllb)) {
                throw new CustomException(10104, "请查看零件配套表组立信息");
            } else {
                wlqd.setDcZl(zllb);
            }
            xh++;
            adds.add(wlqd);
        }
        if (adds.size() > 0) {
            wlqdService.saveBatch(adds);
            insertWpjbbByLjptb(adds);
            //上传文件到服务器
            saveFile(file,path,(String) req.getAttribute("yhms"));
        }
        adds.forEach(e -> {
            UpdateWrapper<DmCzplpNew> qw = new UpdateWrapper<>();
            qw.set("jsq_ptb", DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            qw.eq("dc_ch", e.getDcCh());
            qw.eq("dc_pl", e.getDcPl());
            qw.eq("dc_fd", e.getDcFd());
            dmCzplpNewService.update(qw);
//            UpdateWrapper<DmTzjh> qw1 = new UpdateWrapper<>();
//            qw1.set("jsq_lqb", DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
//            qw1.eq("dc_ch", e.getDcCh());
//            qw1.eq("dc_pl", e.getDcPl());
//            qw1.eq("dc_fd", e.getDcFd());
//            dmTzjhService.update(qw1);
        });
        // 根据文件名字得到第二个- 进行拆分
        return map;
    }
    @Transactional(rollbackFor = Exception.class)
    public void insertWpjbbByLjptb(List<DmWlqd> list) {
        int wph = dmWpjbpServicel.count(new QueryWrapper<DmWpjbp>().eq("wph", list.get(0).getDcCh() + list.get(0).getDcFd()));
        if (wph == 0) {
            DmWpjbp dm = new DmWpjbp();
            dm.setWph(list.get(0).getDcCh() + list.get(0).getDcFd());
            dm.setWpmc("配套表");
            dm.setWpjb("H");
            dm.setDcCh(list.get(0).getDcCh());
            dm.setDcFd(list.get(0).getDcFd());
            dmWpjbpServicel.save(dm);
        }
        List<DmWpjbp> adds = new ArrayList<>();
        for (DmWlqd wlqd : list) {
            int zxwph = dmWpjbpServicel.count(new QueryWrapper<DmWpjbp>().eq("wph", wlqd.getZxwph()));
            if (zxwph == 0) {
//                INSERT INTO DM_WPJBP(WPH,WPMC,WPXH,WPGG,WPJB,GYLB,GYSBH,YHFLH,ABCLX,JLDW,
//                    ZDRY,XGSJ,DC_CH,DC_CM,DC_PL,DC_FD,DC_LPH,JLDW1,WPFLM,DC_TH,DC_ZL,GZLX )
//                VALUES (:ls_wph,:ls_wpmc,:ls_wpxh,:ls_wpgg,:ls_wpjb,:ls_gylb,:ls_gysbh,:ls_hsfl,
//			  :ls_abc,:ls_jldw,:gs_user,:gs_xtrq,:ls_dc_ch,:ls_dc_cm,:ls_dc_pl,:ls_dc_fd,:ls_dc_lph,'19',:ls_wpflm,:ls_dc_th,:ls_dc_zl,'M')
                DmWpjbp dmWpjbp = new DmWpjbp();
                dmWpjbp.setWph(wlqd.getZxwph());
                dmWpjbp.setWpmc(wlqd.getWpmc());
                dmWpjbp.setWpxh("");
                dmWpjbp.setWpgg("");
                dmWpjbp.setWpjb(wlqd.getWpjb());
                dmWpjbp.setGylb(wlqd.getGylb());
                dmWpjbp.setYhflh(wlqd.getGysbh());
                dmWpjbp.setAbclx(wlqd.getAbclx());
                dmWpjbp.setJldw(wlqd.getJldw());
                dmWpjbp.setZdry(wlqd.getZdry());
                dmWpjbp.setXgsj(wlqd.getXgrq());
                dmWpjbp.setDcCh(wlqd.getDcCh());
                dmWpjbp.setDcCm(wlqd.getDcCh());
                dmWpjbp.setDcPl(wlqd.getDcPl());
                dmWpjbp.setDcFd(wlqd.getDcFd());
                dmWpjbp.setDcLph("");
                dmWpjbp.setJldw1("19");
                dmWpjbp.setWpflm(wlqd.getWpflm());
                dmWpjbp.setDcTh(wlqd.getDcTh());
                dmWpjbp.setDcZl(wlqd.getDcZl());
                dmWpjbp.setGzlx("M");
                adds.add(dmWpjbp);
            }
        }
        if (adds.size() > 0) {
            dmWpjbpServicel.saveBatch(adds);
        }
    }
    @Transactional(rollbackFor = Exception.class)
    public void insertwpjbbByxcLq(String wpmc, String wpxh, String wpgg, String ch, String username) {
        String wpid = syService.f_getpjh("SS", "SYSTEM", "WPH");
        DmWpjbp wpjbp = new DmWpjbp();
        wpjbp.setWph(wpid);
        wpjbp.setWpmc(wpmc);
        wpjbp.setWpflm("X");
        wpjbp.setWpxh(wpxh);
        wpjbp.setWpgg(wpgg);
        wpjbp.setDcCh(ch);
        wpjbp.setZdry(username);
        wpjbp.setXgsj(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        wpjbp.setWpjb("Y");
        wpjbp.setGzlx("M");
        wpjbp.setJldw("60");
        wpjbp.setJldw1("19");
        dmWpjbpServicel.save(wpjbp);
    }

    public int ssum(String input, char targetChar) {
        int count = 0;
        for (int i = 0; i < input.length(); i++) {
            if (input.charAt(i) == targetChar) {
                count++;
            }
        }
        return count;
    }

    public List<BomVO> insertBom(HttpServletRequest request, String dcch, String dcpl, String type) throws CustomException {
//        List<DmBom> list = dmBomService.list(new QueryWrapper<DmBom>().eq("sjch", dcch)
//            .eq(StrUtil.isNotEmpty((String) dcpl), "pl",dcpl)
//          );
//        if(list.size()>0){
//            throw new CustomException(10201, "船号"+dcch+"批量"+dcpl +"已经提交bom数据 不可在此生成");
//        }
//        dmBomService.remove(new QueryWrapper<DmBom>().eq("sjch",dcch).eq("pl",dcpl));
        Map querMap = new HashMap();
        querMap.put("dcch", dcch);
        querMap.put("dcpl", dcpl);
//        querMap.put("delx","B");
//        querMap.put("hxfl","B");
        List<DmBclqmxp> bcLQlList = bclqmxpService.getBcLQlList(querMap);
        List<DmBchxmxp> tltList = bchxmxpService.getTLTList(querMap);
        List<DmBchxylp> bcTJlList = bchxylpService.getBcTJlList(querMap);
        List<Dm_zhbmp> zllbs = dm_zhbmpRepository.findByBMLB("ZLLB");
        List<Dm_zhbmp> kwxxs = dm_zhbmpRepository.findByBMLB("KWXX");
        List<Dm_zhbmp> qgkws = dm_zhbmpRepository.findByBMLB("QGKW");
        Map<String, String> zllbMap = zllbs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        Map<String, String> kwxxMap = kwxxs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> qgKwMap = qgkws.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        List<BomVO> adds = new ArrayList<>();
        for (int i = 0; i < bcLQlList.size(); i++) {
            BomVO bomVO = new BomVO();
            bomVO.setBclq(bcLQlList.get(i));
//            bomVO.setBclqs(i);
            adds.add(bomVO);
            bomVO.setCs(1);
        }
        for (int i = 0; i < bcTJlList.size(); ) {
            if (i == adds.size()) {
                BomVO bomVO = new BomVO();
                bomVO.setTjb(bcTJlList.get(i));
                bomVO.setCs(2);
                adds.add(bomVO);
                i++;
            } else {
                for (BomVO v : adds) {
                    v.setTjb(bcTJlList.get(i));
                    v.setCs(2);
                    i++;
                    if (i == bcTJlList.size()) {
                        break;
                    }
                }
            }
        }
        for (int i = 0; i < tltList.size(); ) {
            if (i == adds.size()) {
                BomVO bomVO = new BomVO();
                bomVO.setTlt(tltList.get(i));
                bomVO.setCs(3);
                adds.add(bomVO);
                i++;
            } else {
                for (BomVO v : adds) {
                    v.setTlt(tltList.get(i));
                    v.setCs(3);
                    i++;
                    if (i == tltList.size()) {
                        break;
                    }
                }
            }
        }
        System.out.println(" = " + "tlt over");
//        if (type.equals("01")) {
            List<DmWlqd> ljbList = wlqdService.getLJQDList(querMap);
            for (int i = 0; i < ljbList.size(); ) {
                if (i == adds.size()) {
                    BomVO bomVO = new BomVO();
                    bomVO.setLjb(ljbList.get(i));
                    bomVO.setCs(4);
                    adds.add(bomVO);
                    i++;
                } else {
                    for (BomVO v : adds) {
                        v.setLjb(ljbList.get(i));
                        v.setCs(4);
                        i++;
                        if (i == ljbList.size()) {
                            break;
                        }
                    }
                }
            }
//        }
//        tltList.forEach(e->{
//            if(StringUtils.isNotBlank(e.getWpggZ())){
//
//
//            DmBom dmBom=new DmBom();
//            dmBom.setQgcd(e.getYlzd4Z());
//            dmBom.setHxcd(e.getHxcdZ());
//            dmBom.setTzbh(e.getTzbhZ());
//            dmBom.setTlsl(e.getSl());
//            dmBom.setLjbh(e.getWph());
//            dmBom.setLjsl(e.getLjslZ());
//            dmBom.setSjch(e.getDcChZ());
//            dmBom.setPl(e.getDcPlZ());
//            dmBom.setFd(e.getWph().substring(0,4));
//
//            dmBom.setWpcz(e.getWpxhZ());
//            dmBom.setWpgg(e.getWpggZ());
//            System.out.println("e.getWpggZ().split(\"\\\\*\")[0] = " + e.getWpggZ().split("\\*")[0]);
//            System.out.println("e.getWpggZ().split(\"\\\\*\")[0] = " + e.getWpggZ());
//            dmBom.setBh( new BigDecimal(e.getWpggZ().split("\\*")[0]));
//            dmBom.setBc(new BigDecimal(e.getWpggZ().split("\\*")[2]));
//            String tzbh=e.getTzbhZ();
//            String hxlx="";
//            // 根据图纸编号获取 手工，数控 跨位，组立，、
//            if(tzbh.substring(4,5).equals("S")){
//                hxlx = "1010";
//            }else if(tzbh.substring(4,5).equals("N")){
//                hxlx = "1020";
//            }
//
//            // 跨位
//            String s = kwxxMap.get(tzbh.substring(4,7));
//
//            String zl = this.getZL(tzbh);
//
//            String zlbm = zllbMap.get(zl);
//            String zzcj = qgKwMap.get(s);
//            dmBom.setZl(zlbm);
//            dmBom.setKw(zzcj);
//            dmBom.setLqlb(hxlx);
//            List<DmBchxylp> collect = bcTJlList.stream().filter(fst -> fst.getTzbh().equals(e.getTzbhZ())).collect(Collectors.toList());
//            if(collect.size()>0){
//                dmBom.setTjbs("Y");
//            }
//            List<DmBclqmxp> collect1 = bcLQlList.stream().filter(fst -> fst.getWpgg().equals(e.getWpggZ()) && fst.getWpxh().equals(e.getWpxhZ())
//
//            ).collect(Collectors.toList());
//
//            if(collect1.size()>0){
//                dmBom.setLqbs("Y");
//            }
//        adds.add(dmBom);
//            }
//        });
//       dmBomService.insertBoms(adds);
        return adds;
    }

    public List<DmBom> saveBom(HttpServletRequest request, List<BomVO> list, String czbh, String pl, Integer cs1) throws CustomException {
        if (StringUtils.isNotBlank(czbh) && StringUtils.isNotBlank(pl)) {
            List<DmBom> oloList = dmBomService.list(new QueryWrapper<DmBom>().eq("dcch", czbh)
                .eq("pl", pl)
            );
            Boolean delfag=true;
            for(DmBom e:oloList){
                if("Y".equals(e.getFkgs())){
                    delfag=false;
                    break;
                }
            }

            if (oloList.size() > 0 && delfag ) {

                dmBomService.remove(new QueryWrapper<DmBom>().eq("dcch", czbh).eq("pl", pl));
            } else if (!delfag) {
                throw new CustomException(10106,"不能重新导入请联系管理员");
            }
        }
//        Map querMap= new HashMap();
//        querMap.put("dcch",dcch);
//        querMap.put("dcpl",dcpl);
//        querMap.put("delx","B");
//        querMap.put("hxfl","B");
        List<Dm_zhbmp> zllbs = dm_zhbmpRepository.findByBMLB("ZLLB");
        List<Dm_zhbmp> kwxxs = dm_zhbmpRepository.findByBMLB("KWXX");
        List<Dm_zhbmp> qgkws = dm_zhbmpRepository.findByBMLB("QGKW");
        Map<String, String> zllbMap = zllbs.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        Map<String, String> kwxxMap = kwxxs.stream().collect(Collectors.toMap(Dm_zhbmp::getBM, Dm_zhbmp::getBmsm));
        Map<String, String> qgKwMap = qgkws.stream().collect(Collectors.toMap(Dm_zhbmp::getBmsm, Dm_zhbmp::getBM));
        List<DmBom> adds = new ArrayList<>();
        int cs = list.get(0).getCs();
        if (2 == cs) {
            ArrayList<BomVO> collect = list.stream().collect(
                Collectors.collectingAndThen(
                    Collectors.toCollection(
                        () -> new TreeSet<>(
                            Comparator.comparing(
                                tc -> tc.getTjb().getWpgg() + ";" + tc.getTjb().getWpxh() + ";" + tc.getTjb().getTzbh()))), ArrayList::new));
            collect.forEach(i -> {
                if(null !=i.getTjb()){
                    DmBchxylp e = i.getTjb();
                    if (StringUtils.isNotBlank(e.getWpgg())) {
                        DmBom dmBom = new DmBom();
                        dmBom.setCs(2);
                        // dmBom.setQgcd(e.getYlzd4Z());
                        //dmBom.setHxcd(e.getHxcdZ());
                        dmBom.setTzbh(e.getTzbh());
                        // dmBom.setTlsl(e.getSl());
                        //dmBom.setLjbh(e.getWph());
                        //dmBom.setLjsl(e.getLjslZ());
                        dmBom.setDcch(e.getDcCh());
                        dmBom.setPl(e.getDcPl());
                        dmBom.setBzrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                        dmBom.setBzry((String) request.getAttribute("yhms"));
                        //dmBom.setFd(e.getWph().substring(0,4));
                        dmBom.setSjch(e.getDcCh());
                        dmBom.setWpcz(e.getWpxh());
                        dmBom.setWpgg(e.getWpgg());
                        dmBom.setYlbs(e.getSfyl());
                        System.out.println("e.getWpggZ().split(\"\\\\*\")[0] = " + e.getWpgg().split("\\*")[0]);
                        System.out.println("e.getWpggZ().split(\"\\\\*\")[0] = " + e.getWpgg());
                        dmBom.setBh(new BigDecimal(e.getWpgg().split("\\*")[0]));
                        dmBom.setBc(new BigDecimal(e.getWpgg().split("\\*")[2]));
                        String tzbh = e.getTzbh();
                        String hxlx = "";
                        // 根据图纸编号获取 手工，数控 跨位，组立，、
                        if (tzbh.substring(4, 5).equals("S")) {
                            hxlx = "1010";
                        } else if (tzbh.substring(4, 5).equals("N")) {
                            hxlx = "1020";
                        }
                        // 跨位
                        String s = kwxxMap.get(tzbh.substring(4, 7));
                        String zl = this.getZL(tzbh);
                        String zlbm = zllbMap.get(zl);
                        String zzcj = qgKwMap.get(s);
                        dmBom.setZl(zlbm);
                        dmBom.setKw(zzcj);
                        dmBom.setLqlb(hxlx);
                        dmBom.setYlbhgg(e.getYlggs());
                        // 领取表找打 fds
                        if (e.getHxfl().equals("B")) {
                            dmBom.setType("B");
                            List<BomVO> collect11 = list.stream().filter(fst ->  null!= fst.getBclq() &&fst.getBclq().getWpgg().equals(e.getWpgg()) &&
                                fst.getBclq().getWpxh().equals(e.getWpxh()) && fst.getBclq().getDcPlZ().equals(e.getDcPl())
                            ).collect(Collectors.toList());
                            if (collect11.size() > 0) {
                                dmBom.setFds(collect11.get(0).getBclq().getDcFdZ());
                                // 还需要 一些其他参数 领取重量 实耗重量  余料重量 前批语料代 零件套料重量


                                dmBom.setBcylzl(null==collect11.get(0).getBclq().getYlzl()? null:collect11.get(0).getBclq().getYlzl());
                                dmBom.setBclqzl(null==collect11.get(0).getBclq().getLqzl()? null:collect11.get(0).getBclq().getLqzl());
                                dmBom.setBcshzl(null==collect11.get(0).getBclq().getShzl()? null:collect11.get(0).getBclq().getShzl());
                                dmBom.setBcljtlzl(null==collect11.get(0).getBclq().getLjzl()? null:collect11.get(0).getBclq().getLjzl());
                                dmBom.setBcqpyld(null==collect11.get(0).getBclq().getQpyld()? null:collect11.get(0).getBclq().getQpyld());
                            }
                        } else {

                            BigDecimal cd=e.getXccd().divide(new BigDecimal("1000"));
                            List<BomVO> collect11 = list.stream().filter(fst -> null!= fst.getBclq() && fst.getBclq().getWpxh().equals(e.getWpgg()) &&
                                fst.getBclq().getWpgg().equals(e.getWpxh()) && fst.getBclq().getDcPlZ().equals(e.getDcPl())  && fst.getBclq().getYlzd11().compareTo(cd)==0
                            ).collect(Collectors.toList());
                            if (collect11.size() > 0) {
                                dmBom.setFds(collect11.get(0).getBclq().getDcFdZ());
                                dmBom.setXcgs(collect11.get(0).getBclq().getSl());
                                dmBom.setXcshms(collect11.get(0).getBclq().getShms());
                            }
                            dmBom.setType("X");
                        }
                        adds.add(dmBom);
                    }
                }

            });
        } else {
            list.forEach(i -> {
                if(null!= i.getTlt()){
                    DmBchxmxp e = i.getTlt();
                    if (StringUtils.isNotBlank(e.getWpggZ())) {
                        DmBom dmBom = new DmBom();
                        dmBom.setCs(3);
                        dmBom.setQgcd(e.getYlzd4Z());
                        dmBom.setHxcd(e.getHxcdZ());
                        dmBom.setTzbh(e.getTzbhZ());
                        dmBom.setTlsl(e.getSl());
                        dmBom.setLjbh(e.getWph());
                        dmBom.setLjsl(e.getLjslZ());
                        dmBom.setDcch(e.getDcChZ());
                        dmBom.setPl(e.getDcPlZ());
                        dmBom.setFd(e.getWph().substring(0, 4));
                        dmBom.setSjch(e.getDcChZ());
                        dmBom.setWpcz(e.getWpxhZ());
                        dmBom.setWpgg(e.getWpggZ());
                        dmBom.setBzrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
                        dmBom.setBzry((String) request.getAttribute("yhms"));
                        System.out.println("e.getWpggZ().split(\"\\\\*\")[0] = " + e.getWpggZ().split("\\*")[0]);
                        System.out.println("e.getWpggZ().split(\"\\\\*\")[0] = " + e.getWpggZ());
                        dmBom.setBh(new BigDecimal(e.getWpggZ().split("\\*")[0]));
                        if (e.getWpggZ().split("\\*").length>2){
                            dmBom.setBc(new BigDecimal(e.getWpggZ().split("\\*")[2]));
                        }

                        String tzbh = e.getTzbhZ();
                        String hxlx = "";
                        // 根据图纸编号获取 手工，数控 跨位，组立，、
                        if (tzbh.substring(4, 5).equals("S")) {
                            hxlx = "1010";
                        } else if (tzbh.substring(4, 5).equals("N")) {
                            hxlx = "1020";
                        }
                        // 跨位
                        System.out.println("tzbh = " + tzbh);
                        String s = kwxxMap.get(tzbh.substring(4, 7));
                        String zl = this.getZL(tzbh);
                        String zlbm = zllbMap.get(zl);
                        String zzcj = qgKwMap.get(s);
                        dmBom.setZl(zlbm);
                        dmBom.setKw(zzcj);
                        dmBom.setLqlb(hxlx);
                        //List<BomVO> collecta = list.stream().filter(fst -> null!= fst.getTjb() && fst.getTjb().getTzbh().equals(e.getTzbhZ()) ).collect(Collectors.toList());
                       // dmBom.setYlbs(collecta.get(0).getTjb().getSfyl());
                        //dmBom.setLqbs("Y");
                        if(tzbh.substring(4, 5).equals("X")){ // 型材
                            // 先去 统计表中查找
//                        List<BomVO> collect11 = list.stream().filter(fst -> null!= fst.getTjb() && fst.getTjb().getWpxh().equals(e.getWpxhZ()) &&
//                            fst.getTjb().getWpgg().equals(e.getWpggZ()) && fst.getTjb().getDcPl().equals(e.getDcPlZ())
//                        ).collect(Collectors.toList());
                            List<BomVO> collect11 = list.stream().filter(fst -> null!= fst.getTjb() && tzbh.equals(fst.getTjb().getTzbh())
                            ).collect(Collectors.toList());
                            // 找到长度
                            BigDecimal cd=collect11.get(0).getTjb().getXccd().divide(new BigDecimal("1000"));
                            dmBom.setYlbs(collect11.get(0).getTjb().getSfyl());
                            List<BomVO> collect111 = list.stream().filter(fst -> null!= fst.getBclq() && fst.getBclq().getWpgg().equals(e.getWpxhZ()) &&
                                fst.getBclq().getWpxh().equals(e.getWpggZ()) && fst.getBclq().getDcPlZ().equals(e.getDcPlZ()) && fst.getBclq().getYlzd11().compareTo(cd)==0
                            ).collect(Collectors.toList());
                            if (collect111.size() > 0) {
//                            dmBom.setFds(collect11.get(0).getBclq().getDcFdZ());
                                dmBom.setXcgs(collect111.get(0).getBclq().getSl());
                                dmBom.setXcshms(collect111.get(0).getBclq().getShms());
                                dmBom.setFds(collect111.get(0).getBclq().getDcFdZ());
                            }

                            dmBom.setType("X");
                        }else {

                            List<BomVO> collect11 = list.stream().filter(fst -> null!= fst.getTjb() && tzbh.equals(fst.getTjb().getTzbh())
                            ).collect(Collectors.toList());
                            // 找到长度
                            if(collect11.size()>0){
                                dmBom.setYlbhgg(collect11.get(0).getTjb().getYlggs());

                            }


                            List<BomVO> collect111 = list.stream().filter(fst -> null!= fst.getBclq() && fst.getBclq().getWpgg().equals(e.getWpggZ()) &&
                                fst.getBclq().getWpxh().equals(e.getWpxhZ()) && fst.getBclq().getDcPlZ().equals(e.getDcPlZ())
                            ).collect(Collectors.toList());
                            if (collect111.size() > 0) {
//                            dmBom.setFds(collect11.get(0).getBclq().getDcFdZ());
//                                dmBom.setXcgs(collect111.get(0).getBclq().getSl());
//                                dmBom.setXcshms(collect111.get(0).getBclq().getShms());
                                dmBom.setBcylzl(null==collect111.get(0).getBclq().getYlzl()? null:collect111.get(0).getBclq().getYlzl());
                                dmBom.setBclqzl(null==collect111.get(0).getBclq().getLqzl()? null:collect111.get(0).getBclq().getLqzl());
                                dmBom.setBcshzl(null==collect111.get(0).getBclq().getShzl()? null:collect111.get(0).getBclq().getShzl());
                                dmBom.setBcljtlzl(null==collect111.get(0).getBclq().getLjzl()? null:collect111.get(0).getBclq().getLjzl());
                                dmBom.setBcqpyld(null==collect111.get(0).getBclq().getQpyld()? null:collect111.get(0).getBclq().getQpyld());
                                dmBom.setFds(collect111.get(0).getBclq().getDcFdZ());
                            }


                            dmBom.setType("B");
                        }

                        adds.add(dmBom);
                    }
                }


            });
        }
         // 根据 adds 去找工时定 导入bom时候 根据目标船只的定额数据 给上值
        //    切割之前的定额  船号，批量，组立，跨位，规格，领取类别
        //    切割之后     零件，规格

        DmCbxxp cbbm = dmCbxxpService.getOne(new QueryWrapper<DmCbxxp>().eq("cbbm", czbh));
        if(StringUtils.isNotBlank(cbbm.getSCzbh())){
            List<DmBom> oldList = dmBomService.list(new QueryWrapper<DmBom>().eq("dcch", cbbm.getSCzbh())
                .eq("pl", pl).eq("fkgs","Y")
            );
            for(DmBom dmBom :adds){
                DmBom dmBom1 = oldList.stream().filter(fst -> fst.getDcch().equals(dmBom.getDcch()) && fst.getPl().equals(dmBom.getPl()) &&
                    fst.getZl().equals(dmBom.getZl()) && fst.getKw().equals(dmBom.getKw()) &&
                    fst.getWpgg().equals(dmBom.getWpgg()) && fst.getWpcz().equals(dmBom.getWpcz()) &&
                    fst.getLqlb().equals(dmBom.getLqlb())
                ).findFirst().orElse(null);
                if(null!=dmBom1){
                    dmBom.setFkblgs(dmBom1.getFkblgs());
                    dmBom.setFkpwgs(dmBom1.getFkpwgs());
                    dmBom.setFkllgs(dmBom1.getFkllgs());
                    dmBom.setFkhxgs(dmBom1.getFkhxgs());
                    dmBom.setFkqggs(dmBom1.getFkqggs());
                    dmBom.setFkzpgs(dmBom1.getFkzpgs());
                }
                DmBom dmBom2 = oldList.stream().filter(fst -> fst.getDcch().equals(dmBom.getDcch()) && fst.getPl().equals(dmBom.getPl()) &&
                    fst.getZl().equals(dmBom.getZl()) && fst.getKw().equals(dmBom.getKw()) &&
                    fst.getWpgg().equals(dmBom.getWpgg()) && fst.getWpcz().equals(dmBom.getWpcz()) &&
                    fst.getLqlb().equals(dmBom.getLqlb()) &&fst.getTzbh().equals(dmBom.getTzbh())&&
                    fst.getLjbh().equals(dmBom.getLjbh())
                ).findFirst().orElse(null);
                if(null!=dmBom2){
                    dmBom.setFkpkgs(dmBom2.getFkpkgs());
                    dmBom.setFkqgs(dmBom2.getFkqgs());
                    dmBom.setFkdmgs(dmBom2.getFkdmgs());
                }

            }

        }
        dmBomService.insertBoms(adds);
        return adds;
    }


    // 根据套料图号得到组立信息。
    public String getZL(String tzbh) {
        String bh = tzbh.substring(6, 8);  // 72
        if (tzbh.substring(4, 5).equals("X")) {   // 51
            if ("XX".equalsIgnoreCase(bh)) {
                return "小组立";
            } else if ("XD".equalsIgnoreCase(bh)) {
                return "中大组立";
            }
        } else {
            if ("XX".equalsIgnoreCase(bh)) {
                return "焊接机器人肘板"; // todo 小组
            } else if ("GX".equalsIgnoreCase(bh)) {
                return "光电";   // todo 
            }
        }
        String bh1 = tzbh.substring(7, 8);  // 81
        if ("X".equalsIgnoreCase(bh1)) {
            return "小组立";
        }
        if ("D".equalsIgnoreCase(bh1)) {
            return "中大组立";
        }
        return "";
    }

   public    void saveFile(MultipartFile file,String path,String yhdm){
          String url= com.dsic.gj_erp.util.FileUtil.handlerUpload(file,path);
          bomMapper.insertFile(url,yhdm);
    }


    // 查询 船号 批量 修正作业计划
    public Map  bomxzjh( List<DmBchxjbp> dmBchxjbps,Map kwxxMap,Map qgKwMap , HttpServletRequest req,List<DmBchxmxp>mxs){
        String dcch=dmBchxjbps.get(0).getDcCh();
        String dcpl=dmBchxjbps.get(0).getDcPl();
        Map rMap = new HashMap();
        List<DmBchxylp> tjListOld = bchxylpService.list(new QueryWrapper<DmBchxylp>().eq("dc_ch", dcch).eq("dc_pl", dcpl));


        List<DmBclqmxp> bclqmxpList = bclqmxpService.list(new QueryWrapper<DmBclqmxp>().eq("DC_CH_z", dcch)
            .eq("DC_PL_z", dcpl)
        );
        // todo distnce
        List<DmYdjh> ydjhs = dmYdjhService.list(new QueryWrapper<DmYdjh>().eq("dc_ch", dcch )
            .eq("dc_pl",dcpl)
        );

//        List<DmYdjh> ydjhs1 = dmYdjhService.list(new QueryWrapper<DmYdjh>().eq("dc_ch", dcch )
//            .eq("dc_pl",dcpl).eq("isnull(tzbh,'')","")
//        );
        DmYdjh ydjhMin=null;
        Boolean f=true;
        if(ydjhs.size()<0){
             f=false;
        }else{
             ydjhMin = dmYdjhMapper.getYdjhMin(dcch, dcpl);
        }
        Boolean oneadd=false;
        if(1==ydjhs.size()){
            oneadd=true;
            rMap.put("deyd",ydjhs.get(0).getId());
        }
        List<DmYdjh> adds =new ArrayList<>();
        List<DmYdjh> ups =new ArrayList<>();
        List<DmCbxxp> czList = dmCbxxpService.list();
        DmCbxxp dmCzjbb = czList.stream().filter(fst -> fst.getCbbm().equalsIgnoreCase(dcch)).findFirst().orElse(null);
        String cjs="";
        if(null!=dmCzjbb){
            cjs=dmCzjbb.getCjs();
        }
        String cjs1=cjs;
        for(DmBchxjbp dmBchxjbp1:dmBchxjbps ){
            //wpgg ,wpxh
          //  DmBchxjbp dmBchxjbp = (DmBchxjbp) ObjConvertUtils.checkNullNew(dmBchxjbp1);
            DmBchxjbp dmBchxjbp =    (DmBchxjbp) ObjConvertUtils.checkNullNew(dmBchxjbp1);
//            List<BomVO> collect11 = list.stream().filter(fst ->  null!= fst.getBclq() &&fst.getBclq().getWpgg().equals(e.getWpgg()) &&
//                fst.getBclq().getWpxh().equals(e.getWpxh()) && fst.getBclq().getDcPlZ().equals(e.getDcPl())
//            ).collect(Collectors.toList());
            List<DmBclqmxp> collect11 = bclqmxpList.stream().filter(fst -> fst.getWpgg().equals(dmBchxjbp1.getWpgg()) && fst.getWpxh().equals(dmBchxjbp1.getWpxh())).collect(Collectors.toList());

            DmBchxmxp bchxmxp = mxs.stream().filter(fst -> fst.getHxbh().equals(dmBchxjbp.getHxbh())).findFirst().orElse(null);
            DmBchxylp bchxylp = tjListOld.stream().filter(fst -> fst.getTzbh().equals(dmBchxjbp.getTzbh())
                && fst.getWpgg().equalsIgnoreCase(dmBchxjbp.getWpgg()) && fst.getWpxh().equalsIgnoreCase(dmBchxjbp.getWpxh())
            ).findFirst().orElse(null);
            // dmBchxjbp
            String wpgg = dmBchxjbp.getWpgg();
            String wpxh = dmBchxjbp.getWpxh();
            String tzbh = dmBchxjbp.getTzbh();
            String hxfl = dmBchxjbp.getHxfl();
            if(StringUtils.isBlank(wpgg)||"hxfl".equals("X")){
                continue;
            }
            // 根据 材质 规格 去找  生产计划
            DmYdjh dmYdjh = ydjhs.stream()
                .filter(fst -> StringUtils.isNotBlank(fst.getWpgg())
                    &&  StringUtils.isNotBlank(fst.getWpxh())
                    && fst.getWpgg().equalsIgnoreCase(dmBchxjbp.getWpgg())
                    && (fst.getWpxh().equalsIgnoreCase(dmBchxjbp.getWpxh())
                    || (cjs1 + fst.getWpxh()).equalsIgnoreCase(dmBchxjbp.getWpxh())  ||  ( fst.getWpxh()).equalsIgnoreCase(cjs1 +dmBchxjbp.getWpxh()))
                    && fst.getTzbh().equalsIgnoreCase(dmBchxjbp.getTzbh())
                )
                .findFirst()
                .orElse(null);
            if(null!=dmYdjh){

                String hxlx="";
                if (tzbh.substring(4, 5).equals("S")) {
                    hxlx = "1010";
                } else if (tzbh.substring(4, 5).equals("N")) {
                    hxlx = "1020";
                }

                dmYdjh.setLqlb(hxlx);
                dmYdjh.setTzbh(tzbh);
                dmYdjh.setHxcd(dmBchxjbp.getHxcd().doubleValue());
                dmYdjh.setQgcd(dmBchxjbp.getYlzd4().doubleValue());
                dmYdjh.setLjsl(dmBchxjbp.getLjsl().doubleValue());
                dmYdjh.setZl(dmBchxjbp.getDcZl());
                String s = (String) kwxxMap.get(tzbh.substring(4, 7));
                String zzcj = (String) qgKwMap.get(s); //xhj

                dmYdjh.setKw(zzcj);
                if(null!=bchxylp){
                    dmYdjh.setYlbs(null==bchxylp.getSfyl()?"":bchxylp.getSfyl());
                }

               // dmYdjh.setDcFd(dmBchxjbp.getDcFd());

                if(tzbh.substring(4, 5).equals("X")){
                    dmYdjh.setLx("X");
                }else{
                    dmYdjh.setLx("B");
                }
                dmYdjh.setDcFd(StringUtils.isBlank(bchxmxp.getWph()) ? "" : bchxmxp.getWph().substring(0, 4));
                dmYdjh.setBmxgrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm"));
                dmYdjh.setBmxgry((String) req.getAttribute("yhms"));
                if(StringUtils.isNotBlank(dmYdjh.getSlxhth())){ // 说明已经上料 需要修正数据
                     // 修正

                }else{
                   // 没上料 规格材质
                    dmYdjh.setWpgg(dmBchxjbp.getWpgg());
                    dmYdjh.setWpxh(dmBchxjbp.getWpxh());
                }
                if(collect11.size()>0){
                    dmYdjh.setBcylzl(null==collect11.get(0).getYlzl()? null:collect11.get(0).getYlzl().doubleValue());
                    dmYdjh.setBclqzl(null==collect11.get(0).getLqzl()? null:collect11.get(0).getLqzl().doubleValue());
                    dmYdjh.setBcshzl(null==collect11.get(0).getShzl()? null:collect11.get(0).getShzl().doubleValue());
                    dmYdjh.setBcljtlzl(null==collect11.get(0).getLjzl()? null:collect11.get(0).getLjzl().doubleValue());
                    dmYdjh.setBcqpyld(null==collect11.get(0).getQpyld()? null:collect11.get(0).getQpyld().doubleValue());
                }

                if(f){
                    dmYdjh.setSlrq(ydjhMin.getSlrq());
                    dmYdjh.setPwrq(ydjhMin.getPwrq());
                    dmYdjh.setHxrq(ydjhMin.getHxrq());
                    dmYdjh.setQgrq(ydjhMin.getQgrq());
                    dmYdjh.setDmrq(ydjhMin.getDmrq());
                    dmYdjh.setQjgrq(ydjhMin.getQgjhrq());
                    dmYdjh.setJssj(ydjhMin.getJssj());
                    dmYdjh.setSljhrq(ydjhMin.getSljhrq());
                    dmYdjh.setPwjhrq(ydjhMin.getPwjhrq());
                    dmYdjh.setLljhrq(ydjhMin.getLljhrq());
                    dmYdjh.setHxjhrq(ydjhMin.getHxjhrq());
                    dmYdjh.setQgjhrq(ydjhMin.getQgjhrq());
                }

                ups.add(dmYdjh);
                ydjhs.remove(dmYdjh); // 从列表中移除找到的元素

            }else{
                 dmYdjh = ydjhs.stream()
                    .filter(fst -> StringUtils.isNotBlank(fst.getWpgg())
                        &&  StringUtils.isNotBlank(fst.getWpxh())
                        && fst.getWpgg().equalsIgnoreCase(dmBchxjbp.getWpgg())
                        && (fst.getWpxh().equalsIgnoreCase(dmBchxjbp.getWpxh())
                        || (cjs1 + fst.getWpxh()).equalsIgnoreCase(dmBchxjbp.getWpxh())  ||  ( fst.getWpxh()).equalsIgnoreCase(cjs1 +dmBchxjbp.getWpxh()) )

                    )
                    .findFirst()
                    .orElse(null);
                if(dmYdjh!=null){
                    String hxlx="";
                    if (tzbh.substring(4, 5).equals("S")) {
                        hxlx = "1010";
                    } else if (tzbh.substring(4, 5).equals("N")) {
                        hxlx = "1020";
                    }
                    if(collect11.size()>0) {
                        dmYdjh.setBcylzl(null == collect11.get(0).getYlzl() ? null : collect11.get(0).getYlzl().doubleValue());
                        dmYdjh.setBclqzl(null == collect11.get(0).getLqzl() ? null : collect11.get(0).getLqzl().doubleValue());
                        dmYdjh.setBcshzl(null == collect11.get(0).getShzl() ? null : collect11.get(0).getShzl().doubleValue());
                        dmYdjh.setBcljtlzl(null == collect11.get(0).getLjzl() ? null : collect11.get(0).getLjzl().doubleValue());
                        dmYdjh.setBcqpyld(null == collect11.get(0).getQpyld() ? null : collect11.get(0).getQpyld().doubleValue());
                    }
                    dmYdjh.setLqlb(hxlx);
                    dmYdjh.setTzbh(tzbh);
                    dmYdjh.setHxcd(dmBchxjbp.getHxcd().doubleValue());
                    dmYdjh.setQgcd(dmBchxjbp.getYlzd4().doubleValue());
                    dmYdjh.setLjsl(dmBchxjbp.getLjsl().doubleValue());
                    dmYdjh.setZl(dmBchxjbp.getDcZl());
                    if(null!=bchxylp) {
                        dmYdjh.setYlbs(null == bchxylp.getSfyl() ? "" : bchxylp.getSfyl());
                    }
                    String s = (String) kwxxMap.get(tzbh.substring(4, 7));
                    String zzcj = (String) qgKwMap.get(s); //xhj

                    dmYdjh.setKw(zzcj);
                    // dmYdjh.setDcFd(dmBchxjbp.getDcFd());

                    if(tzbh.substring(4, 5).equals("X")){
                        dmYdjh.setLx("X");
                    }else{
                        dmYdjh.setLx("B");
                    }

                    dmYdjh.setDcFd(StringUtils.isBlank(bchxmxp.getWph()) ? "" : bchxmxp.getWph().substring(0, 4));
                    dmYdjh.setBmxgrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm"));
                    dmYdjh.setBmxgry((String) req.getAttribute("yhms"));
                    if(StringUtils.isNotBlank(dmYdjh.getSlxhth())){ // 说明已经上料 需要修正数据
                        // 修正
                        dmYdjh.setJhlx("3");
                    }else{
                        // 没上料 规格材质
                        dmYdjh.setWpgg(dmBchxjbp.getWpgg());
                        dmYdjh.setWpxh(dmBchxjbp.getWpxh());
                    }
                    if(f){
                        dmYdjh.setSlrq(ydjhMin.getSlrq());
                        dmYdjh.setPwrq(ydjhMin.getPwrq());
                        dmYdjh.setHxrq(ydjhMin.getHxrq());
                        dmYdjh.setQgrq(ydjhMin.getQgrq());
                        dmYdjh.setDmrq(ydjhMin.getDmrq());
                        dmYdjh.setQjgrq(ydjhMin.getQgjhrq());
                        dmYdjh.setJssj(ydjhMin.getJssj());
                        dmYdjh.setSljhrq(ydjhMin.getSljhrq());
                        dmYdjh.setPwjhrq(ydjhMin.getPwjhrq());
                        dmYdjh.setLljhrq(ydjhMin.getLljhrq());
                        dmYdjh.setHxjhrq(ydjhMin.getHxjhrq());
                        dmYdjh.setQgjhrq(ydjhMin.getQgjhrq());
                    }
                    ups.add(dmYdjh);
                    ydjhs.remove(dmYdjh); // 从列表中移除找到的元素

                }else{
                    // 没找到需要把这几条月度计划id 状态改成 -1

                    DmYdjh  dmYdjhadd =new DmYdjh();
                    String hxlx="";
                    if (tzbh.substring(4, 5).equals("S")) {
                        hxlx = "1010";
                    } else if (tzbh.substring(4, 5).equals("N")) {
                        hxlx = "1020";
                    }
                    dmYdjhadd.setDcCh(dmBchxjbp.getDcCh());
                    dmYdjhadd.setDcPl(dmBchxjbp.getDcPl());
                    if(tzbh.substring(4, 5).equals("X")){
                        dmYdjhadd.setLx("X");
                    }else{
                        dmYdjhadd.setLx("B");
                    }

                    dmYdjhadd.setWpgg(dmBchxjbp.getWpgg());
                    dmYdjhadd.setWpxh(dmBchxjbp.getWpxh());
                    if(null!=bchxylp){
                        dmYdjhadd.setYlbs( null==bchxylp.getSfyl()?"":bchxylp.getSfyl());
                    }
                    if(collect11.size()>0) {
                        dmYdjhadd.setBcylzl(null == collect11.get(0).getYlzl() ? null : collect11.get(0).getYlzl().doubleValue());
                        dmYdjhadd.setBclqzl(null == collect11.get(0).getLqzl() ? null : collect11.get(0).getLqzl().doubleValue());
                        dmYdjhadd.setBcshzl(null == collect11.get(0).getShzl() ? null : collect11.get(0).getShzl().doubleValue());
                        dmYdjhadd.setBcljtlzl(null == collect11.get(0).getLjzl() ? null : collect11.get(0).getLjzl().doubleValue());
                        dmYdjhadd.setBcqpyld(null == collect11.get(0).getQpyld() ? null : collect11.get(0).getQpyld().doubleValue());
                    }
                    dmYdjhadd.setLqlb(hxlx);
                    dmYdjhadd.setTzbh(tzbh);
                    dmYdjhadd.setHxcd(dmBchxjbp.getHxcd().doubleValue());
                    dmYdjhadd.setQgcd(dmBchxjbp.getYlzd4().doubleValue());
                    dmYdjhadd.setLjsl(dmBchxjbp.getLjsl().doubleValue());
                    dmYdjhadd.setZl(dmBchxjbp.getDcZl());
                    String s = (String) kwxxMap.get(tzbh.substring(4, 7));
                    String zzcj = (String) qgKwMap.get(s); //xhj
                    dmYdjhadd.setKw(zzcj);
                    dmYdjhadd.setDcFd(StringUtils.isBlank(bchxmxp.getWph()) ? "" : bchxmxp.getWph().substring(0, 4));
                    dmYdjhadd.setZt("2");

                    dmYdjhadd.setId(IdWorker.get32UUID());
                    dmYdjhadd.setBmbzrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm"));
                    dmYdjhadd.setBmbzry((String) req.getAttribute("yhms"));

                    // 新增数据得时候 应该看 是不是有排产数据  有排产数据 给上日期
                    if(f){
                        dmYdjhadd.setSlrq(ydjhMin.getSlrq());
                        dmYdjhadd.setPwrq(ydjhMin.getPwrq());
                        dmYdjhadd.setHxrq(ydjhMin.getHxrq());
                        dmYdjhadd.setQgrq(ydjhMin.getQgrq());
                        dmYdjhadd.setDmrq(ydjhMin.getDmrq());
                        dmYdjhadd.setQjgrq(ydjhMin.getQgjhrq());
                        dmYdjhadd.setJssj(ydjhMin.getJssj());
                        dmYdjhadd.setSljhrq(ydjhMin.getSljhrq());
                        dmYdjhadd.setPwjhrq(ydjhMin.getPwjhrq());
                        dmYdjhadd.setLljhrq(ydjhMin.getLljhrq());
                        dmYdjhadd.setHxjhrq(ydjhMin.getHxjhrq());
                        dmYdjhadd.setQgjhrq(ydjhMin.getQgjhrq());
                        dmYdjhadd.setJhlx("3");
                    }else{
                        // 新增 没有 日期 数据
                        dmYdjhadd.setJhlx("0");
                        dmYdjhadd.setSlrq("");
                        dmYdjhadd.setPwrq("");
                        dmYdjhadd.setHxrq("");
                        dmYdjhadd.setQgrq("");
                        dmYdjhadd.setDmrq("");
                        dmYdjhadd.setQjgrq("");
                        dmYdjhadd.setJssj("");
                        dmYdjhadd.setSljhrq("");
                        dmYdjhadd.setPwjhrq("");
                        dmYdjhadd.setLljhrq("");
                        dmYdjhadd.setHxjhrq("");
                        dmYdjhadd.setQgjhrq("");
                    }
//                dmYdjhadd
                    adds.add(dmYdjhadd);
                }




            }

        }





        rMap.put("adds",adds);
        rMap.put("ups",ups);
        rMap.put("ydjhs",ydjhs);
      return rMap;
    }

}
