package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.bean.copier.CopyOptions;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.*;
import com.dsic.gj_erp.bean.jhgk.*;
import com.dsic.gj_erp.bean.jhgk.dto.*;
import com.dsic.gj_erp.bean.jhgk.excel.JhxfExcel;
import com.dsic.gj_erp.bean.sy.Dm_zhbmp;
import com.dsic.gj_erp.dao.sy.Dm_zhbmpRepository;
import com.dsic.gj_erp.handler.ComputePlan;
import com.dsic.gj_erp.handler.dto.RealCapacity;
import com.dsic.gj_erp.mapper.jhgk.DmSygdMxMapper;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import com.dsic.gj_erp.service.jhgk.*;
import com.dsic.gj_erp.util.MyString;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.*;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicReference;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@Service
public class DmSygdMxServiceImpl extends ServiceImpl<DmSygdMxMapper, DmSygdMx> implements DmSygdMxService {

    @Resource
    private DmSygdService sygdService;
    @Resource
    private DmXbjhService xbService;
    @Resource
    private DmTzjhService tzjhService;
    @Resource
    private DmSygdMxLjServiceImpl ljService;
    @Resource
    private EmSbcnpService sbcnpService;
    @Autowired
    Dm_zhbmpRepository dm_zhbmpRepository;
    @Autowired
    DmBomService bomService;
    @Autowired
    DmYdjhService ydjhService;
    @Autowired
    IYdjhImportService ydjhImportService;

    @Autowired
    private RedisTemplate<String,Object> redisTemplate;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void tj(String from,String to){
        List<DmSygdMx> sygdMxes = this.list(Wrappers.<DmSygdMx>lambdaQuery()
                .eq(DmSygdMx::getZt,"0")
                .between(DmSygdMx::getJssj, from, to)
        );
        if (ObjectUtil.isNotEmpty(sygdMxes)){
            List<DmSygdMx> collect = sygdMxes.stream().map(dmSygd -> {
                DmSygdMx dmSygdMx = new DmSygdMx();
                dmSygdMx.setId(dmSygd.getId());
                dmSygdMx.setZt("1");
                return dmSygdMx;
            }).collect(Collectors.toList());
            this.updateBatchById(collect);
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void sh(String from,String to){
        List<DmSygdMx> sygdMxes = this.list(Wrappers.<DmSygdMx>lambdaQuery()
                .eq(DmSygdMx::getZt,"1")
                .between(DmSygdMx::getJssj, from, to)
        );
        if (ObjectUtil.isNotEmpty(sygdMxes)){
            List<DmSygdMx> collect = sygdMxes.stream().map(dmSygd -> {
                DmSygdMx dmSygdMx = new DmSygdMx();
                dmSygdMx.setId(dmSygd.getId());
                dmSygdMx.setZt("2");
                return dmSygdMx;
            }).collect(Collectors.toList());
            this.updateBatchById(collect);

            //生成作业计划
            List<DmYdjh> dmYdjhs = this.generateYdjh(sygdMxes);

            String gxsj=DateUtil.date().toString("yyyy/MM/dd HH:mm:ss");
            Map<String, List<DmYdjh>> map = dmYdjhs.stream().collect(Collectors.groupingBy(it -> it.getDcCh() + "_" + it.getDcPl()));
            map.forEach((key,val)->{
                String plXh = this.getPlGdh();
                val.forEach(item-> item.setPlxh(plXh));
            });

            //工单号
            List<DmYdjh> updateList = dmYdjhs.stream()
                    .filter(item->StrUtil.isNotEmpty(item.getSljhrq()))
                    .map(item->ofXf(item,gxsj)).collect(Collectors.toList());

            ydjhService.updateBatchById(updateList);
        }
    }

    private DmYdjh ofXf(DmYdjh item,String gxsj){
        Long djh=this.handlerDjh(item);
        DmYdjh dmYdjh = new DmYdjh();
        dmYdjh.setId(item.getId());
        dmYdjh.setZt("2");
        String perfix=item.getSljhrq().replace("/","");
        perfix=perfix.substring(2);
        dmYdjh.setDjh(StrUtil.format("{}{}",perfix, String.format("%03d",djh)));
        dmYdjh.setGxsj(gxsj);
        dmYdjh.setPlxh(item.getPlxh());
        return dmYdjh;
    }

    private Long handlerDjh(DmYdjh item){
        String key="ZYJH_GDH::";
        //从101开始生成工单号,方便工人念出
        if (ObjUtil.isEmpty(redisTemplate.opsForHash().get(key, item.getSljhrq()))) {
            redisTemplate.opsForHash().put(key, item.getSljhrq(),100);
        }
        return redisTemplate.opsForHash().increment(key, item.getSljhrq(), 1);
    }

    private String getPlGdh(){
        String date=DateUtil.date().toString("yyyyMMdd");
        String key="ZYJH_PLGDH::";
        Object o = redisTemplate.opsForHash().get(key, date);
        if (ObjUtil.isEmpty(o)) {
            redisTemplate.opsForHash().put(key, date,100);
        }
        Long xh=redisTemplate.opsForHash().increment(key, date, 1);
        return StrUtil.format("{}{}",date, String.format("%03d",xh));
    }

    private List<DmYdjh> generateYdjh(List<DmSygdMx> sygdMxes){
        List<DmYdjh> list=new ArrayList<>();
        HashMap<String, Object> map = new HashMap<>();
        for(DmSygdMx item:sygdMxes){
            Object o = map.get(item.getDcCh() + item.getDcPl());
            AtomicBoolean continueFlag= new AtomicBoolean(false);
            if (ObjectUtil.isEmpty(o)){
                List<YdjhImport> list1 = ydjhImportService.list(Wrappers.<YdjhImport>lambdaQuery()
                        .eq(YdjhImport::getDcCh, item.getDcCh()));
                list1.forEach(jh->{
                    if (jh.getDcPl().contains("Q")) {
                        jh.setDcPl(jh.getDcPl().replace("Q", ""));
                    }

                    try {
                        String format = String.format("%03d", Integer.parseInt(item.getDcPl()));
                        jh.setDcPl(format);
                    } catch (Exception ignored) {
                    }
                    //没有基础数据在作业计划表中插入一条仅有日期的新数据
                    if(!"1".equals(jh.getExtData())&&item.getDcCh().equals(jh.getDcCh())&&item.getDcPl().equals(jh.getDcPl())){
                        map.put(item.getDcCh()+item.getDcPl(),"1");
                        DmYdjh dmYdjh = new DmYdjh();
                        dmYdjh.setDcCh(jh.getDcCh());
                        dmYdjh.setDcPl(jh.getDcPl());
                        dmYdjh.setJssj(item.getJssj());
                        dmYdjh.setDcCh1(jh.getExtData());//不是“0”为目标船只，“0”表示无
                        dmYdjh.setSljhrq(item.getSlrq());
                        dmYdjh.setPwjhrq(item.getPwrq());
                        dmYdjh.setLljhrq(item.getLlrq());
                        dmYdjh.setHxjhrq(item.getQgrq());
                        dmYdjh.setQgjhrq(item.getQgrq());
                        boolean addFlag=true;
                        for (DmYdjh ydjh:list){
                            if (ydjh.getDcCh().equals(dmYdjh.getDcCh())&&ydjh.getDcPl().equals(ydjh.getDcPl())){
                                addFlag=false;
                            }
                        }
                        if (addFlag){
                            list.add(dmYdjh);
                        }
                        continueFlag.set(true);
                    }
                });
            }
            if (continueFlag.get()){
                continue;
            }
            List<DmYdjh> ydjhList = ydjhService.list(Wrappers.<DmYdjh>query()
                    .eq("dc_ch",item.getDcCh())
                    .eq("dc_pl",item.getDcPl())
                    .eq("tzbh",item.getTzbh())
            );

            for(DmYdjh dmYdjh:ydjhList){
                if (dmYdjh.getDcCh().equals(item.getDcCh())
                        &&dmYdjh.getDcPl().equals(item.getDcPl())
                        &&dmYdjh.getTzbh().equals(item.getTzbh())
                ){
                    dmYdjh.setId(dmYdjh.getId());

                    this.updateYdjh(dmYdjh,item);

                    //比对数据
                    dmYdjh.setXzglxq(dmYdjh.getJssj());
                    if (StrUtil.isAllNotEmpty(dmYdjh.getXzglxq(),dmYdjh.getJssj())){
                        //状态 2拖期 1提前 3追加
                        if (dmYdjh.getXzglxq().compareTo(dmYdjh.getJssj())<0){
                            if (!DateUtil.isSameMonth(DateUtil.parseDate(dmYdjh.getXzglxq()),DateUtil.parseDate(dmYdjh.getJssj()))){
                                dmYdjh.setJhlx("3");
                            }else {
                                dmYdjh.setJhlx("1");
                            }
                        }
                        if (dmYdjh.getXzglxq().compareTo(dmYdjh.getJssj())>0){
                            dmYdjh.setJhlx("2");
                        }
                        dmYdjh.setJssjOld(StrUtil.isEmpty(dmYdjh.getJssj())?"":dmYdjh.getJssj());
                        dmYdjh.setJssj(dmYdjh.getXzglxq());
                    }
                    if (StrUtil.isEmpty(dmYdjh.getTzbh())){
                        dmYdjh.setJhlx("3");
                    }
                    list.add(dmYdjh);
                }
//                else{
//                    DmYdjh dmYdjh1 = new DmYdjh();
//                    this.updateYdjh(dmYdjh1,item);
//                    list.add(dmYdjh1);
//                }
            }
        }
        return list;
    }

    private void updateYdjh(DmYdjh dmYdjh,DmSygdMx item){
        //计划日期
        dmYdjh.setJssj(item.getJssj());
        dmYdjh.setSljhrq(item.getSlrq());
        dmYdjh.setPwjhrq(item.getPwrq());
        dmYdjh.setHxjhrq(item.getHxrq());
        dmYdjh.setQgjhrq(item.getQgrq());

        //重量
        dmYdjh.setBclqzl(item.getBclqzl());
        dmYdjh.setBcshzl(item.getBcshzl());
        dmYdjh.setBcylzl(item.getBcylzl());
        dmYdjh.setBcljtlzl(item.getBcljtlzl());
    }

    public Map<String,List<EmGcrlDto>> getMxMap(String begin,String end){

        List<EmGcrlDto> list=baseMapper.getMxMap(begin,end);
        //1.页面 arr=[日期+工序+设备,...]
        //2.后端1 日期范围查询 所有加工内容 按日期+工序+设备 分组
        //上料
        Map<String,List<EmGcrlDto>> mx=  list.stream().collect(Collectors.groupingBy(l->l.getSlrq()+l.getSlgxbm()+l.getSlsb()));
        //抛丸
        Map<String,List<EmGcrlDto>> mxPwMap=  list.stream().collect(Collectors.groupingBy(l->l.getPwrq()+l.getPwgxbm()+l.getPwsb()));
        //划线
        Map<String,List<EmGcrlDto>> mxHxMap=  list.stream().collect(Collectors.groupingBy(l->l.getHxrq()+l.getHxgxbm()+l.getHxsb()));
        //切割
        Map<String,List<EmGcrlDto>> mxQgMap=  list.stream().collect(Collectors.groupingBy(l->l.getQgrq()+l.getQggxbm()+l.getQgsb()));
        //坡口
        Map<String,List<EmGcrlDto>> mxPkMap=  list.stream().collect(Collectors.groupingBy(l->l.getPkrq()+l.getPkgxbm()+l.getPksb()));
        //打磨
        Map<String,List<EmGcrlDto>> mxDmMap=  list.stream().collect(Collectors.groupingBy(l->l.getDmrq()+l.getDmgxbm()+l.getDmsb()));
        //曲
        Map<String,List<EmGcrlDto>> mxQMap=  list.stream().collect(Collectors.groupingBy(l->l.getQjgrq()+l.getQjggxbm()+l.getQsb()));

        mx.putAll(mxPwMap);
        mx.putAll(mxHxMap);
        mx.putAll(mxQgMap);
        mx.putAll(mxPkMap);
        mx.putAll(mxDmMap);
        mx.putAll(mxQMap);
        //循环第二布查询结果 取bom

        //3.后端 日期范围查询所有的需求

        //4.页面 按照后端1提取list 循环匹配 需求 （同时包含bom）
        //把第4步的结果赋值到table
        return mx;
    }
    @Override
    public List<Kwdto> getGcrlList(List<DmSygdMx> list,String begin,String end) {
//    1.根据list汇总
        Map<String,List<EmGcrlDto>> listMap= getMxMap(begin,end);
        //三月滚动明细  船号 批量 分段 图纸编号 工序 工序加工日期
        //工厂日历 -> 工序+设备 ->三月滚动明细 - 分段钢料滚动需求
        //工序
        ComputePlan c=ComputePlan.instance();
        c.computeRealCapacity(DateUtil.parse(begin,"yyyy/MM/dd"), DateUtil.parse(end,"yyyy/MM/dd"));
        JSONObject realDeviceList=c.getRealDeviceList();
        List<EmGcrl>  gcrlList=c.getGcrlList();

        List<Dm_zhbmp> pcgx = dm_zhbmpRepository.findByBMLB("PCGX");
        gcrlList.forEach(gcrl->{
            String jgrq=gcrl.getGl();
            Map<String,List<EmSbjbb>> map=new HashMap<>();
            //日期+设备list（工序）
            if (realDeviceList.size()>1 && ObjectUtil.isNotEmpty(realDeviceList.getJSONArray(gcrl.getGl()))) {
                //根据工序分组
                JSONArray data =realDeviceList.getJSONArray(gcrl.getGl());
                String js = JSONObject.toJSONString(data, SerializerFeature.WriteClassName);
                List<EmSbjbb> list1=JSONObject.parseArray(js, EmSbjbb.class);
                map=list1.stream().collect(Collectors.groupingBy(EmSbjbb::getGx));
            }
            //1.页面 arr=[日期+工序+设备,...]
            //2.后端1 日期范围查询所有加工内容 按日期+工序+设备
            //循环第二布查询结果 取bom

            //3.后端 日期范围查询所有的需求

            //4.页面 按照后端1提取list 循环匹配 需求 （同时包含bom）
            //把第4步的结果赋值到table

            //日期 工序
            for (Dm_zhbmp dmZhbmp : pcgx) {
                String gx=dmZhbmp.getBM();
                if (ObjectUtil.isNotEmpty(map)
                        &&ObjectUtil.isNotEmpty(map.get(gx))
                        &&map.get(gx).size()>0){
                    List<EmSbjbb> sbList= map.get(gx);
                    for (EmSbjbb emSbjbb : sbList) {
                        String sbbh=emSbjbb.getSbbh();
                         if (ObjectUtil.isNotEmpty(listMap.get(jgrq+gx+sbbh))&&listMap.get(jgrq+gx+sbbh).size()>0){
                             List<EmGcrlDto> l= listMap.get(jgrq+gx+sbbh);
                             l.stream().collect(Collectors.groupingBy(dto->dto.getDcCh()+dto.getDcPl()+dto.getDcFd()));
                         }
                    }
                }
            }
        });
        return new ArrayList<>();
    }

    EmGcrlDto getFdglxqs(String gx,DmSygdMx mx,EmGcrl gcrl,EmSbjbb emSbjbb){
        List<DmSygdxq> dmSygdxqs=  baseMapper.getGlgdxq(mx);
        // 新增一个对象
        EmGcrlDto dto=new EmGcrlDto();
        for (DmSygdxq dmSygdxq : dmSygdxqs) {
            dto=BeanUtil.copyProperties(dmSygdxq,EmGcrlDto.class);
            dto.setGl(gcrl.getGl());
            dto.setBbgs(gcrl.getBbgs());
            dto.setYbgs(gcrl.getYbgs());
            dto.setGx(gx);
            dto.setSbbh(emSbjbb.getSbbh());
            dto.setSbmc(emSbjbb.getSbmc());
            dto.setDegsYb(emSbjbb.getDegsYb());
            dto.setDegs(emSbjbb.getDegs());

//            dto.setBomList();
        }
        return dto;
    }
    /**
     * 采购计划到货情况
     */
    public Object cgjhdhqk(Map<String, Object> map) {
        return baseMapper.cgjhdhqk(map);
    }



    /**
     * 三月滚动需求期排产
     * 滚动需求期信息，提取相应的BOM数据，后合并到套料图级别
     * 默认提取未来3个月信息
     *
     * @return
     */
    @Override
    @Transactional
    public ResultBean sygdPC() {
        //todo 重复导入（三月滚动计划）的数据处理
        //零件 删除
//        String begin=DateUtil.format(DateUtil.nextMonth(),"yyyy/MM/01");
//        String end =DateUtil.format(DateUtil.endOfMonth(DateUtil.offsetMonth(DateUtil.date(),3)),"yyyy/MM/dd");
        //测试日期
        String begin = "2023/08/01";
        String end = "2023/10/31";
        //todo 零件
        ljService.remove(new QueryWrapper<DmSygdMxLj>().between("xzglxq", begin, end));
        //todo 三月滚动明细
        this.remove(new QueryWrapper<DmSygdMx>().between("jssj", begin, end));
        //todo 三月滚动计划
        sygdService.remove(new QueryWrapper<DmSygd>().between("sl_sj", begin, end));

        baseMapper.getLjxx(begin, end);
        List<DmSygdMxLj> ljList = ljService.list(new QueryWrapper<DmSygdMxLj>().between("xzglxq", begin, end));

        if (ljList.size() < 1) {
            return new ResultBean(false, 1, "请先导入" + begin + " ~ " + end + "分段钢料需求！");
        }

        //2.根据
        List<DmSygdMx> mxList = baseMapper.getMx(begin, end);
        //todo 排产
        ypc(mxList);
        this.saveBatch(mxList);

        baseMapper.setParent(begin, end);

        List<DmYdjhxf> list= tqSygd1(begin,end);
//        ResultBean r = new ResultBean(mxList);
        ResultBean r = new ResultBean(list);
        r.setSuccess(true);
        return r;
    }

    /**
     * 预排产，根据套料图号及跨位
     *
     * @param list 三月滚动明细
     */
    public void ypc(List<DmSygdMx> list) {
        //可用设备/产能 根据日期、跨位+工序 分组
        ComputePlan c=ComputePlan.instance();
        c.computeRealCapacity(DateUtil.beginOfMonth(DateUtil.date()), DateUtil.endOfMonth(DateUtil.date()));
        Map<String,Map<String,List<RealCapacity>>> rel=c.getRealCapacityMap();

        //产能
        List<EmSbcnp> sbcnp =c.getSbcnList();
        Map<String, List<EmSbcnp>> cnMap = sbcnp.stream().collect(Collectors.groupingBy(l -> l.getTzbh() + l.getZl()));

        list.forEach(l->{
            List<EmSbcnp> jgsxList= cnMap.get(l.getKw()+l.getZl());
            if (ObjectUtil.isNotEmpty(jgsxList)&&jgsxList.size()>0 ){
                jggx(rel,l,jgsxList);
            }
        });

    }

    /**
     *
     * @param rel 真实产能
     * @param l 当前加工钢板
     * @param list  加工顺序
     */
    public void jggx( Map<String,Map<String,List<RealCapacity>>> rel,DmSygdMx l,List<EmSbcnp> list){
        String date="";
        Map<String,String> map;
        for (EmSbcnp cn : list) {
            //上料
            if (cn.getGx().equals("19")) {
                map=xhcn(rel,null,cn.getGx(),1, date);
                date=map.get("jgsj");
                l.setSlrq(date);
                l.setSlsb(map.get("sbbh"));
                l.setSlgxbm("19");
            }
            //抛丸
            if (cn.getGx().equals("20")) {
                map=xhcn(rel,null,cn.getGx(),1, date);
                date=map.get("jgsj");
                l.setPwrq(date);
                l.setPwsb(map.get("sbbh"));
                l.setPwgxbm("20");
            }
            //理料
            if (cn.getGx().equals("21")) {
                map=xhcn(rel,null,cn.getGx(),1, date);
                date=map.get("jgsj");
                l.setLlrq(date);
                l.setLlsb(map.get("sbbh"));
                l.setLlgxbm("21");
            }
            // 划线
            if ("01,02".indexOf(cn.getGx()) > -1 && l.getHxcd()>0) {
                map=xhcn(rel,cn.getKw(),cn.getGx(),1, date);
                date=map.get("jgsj");
                l.setHxrq(date);
                l.setHxsb(map.get("sbbh"));
                l.setHxgxbm(cn.getGx());
            }
            //切割
            if ("03,04,05,06,07".indexOf(cn.getGx()) > -1 && l.getQgcd()>0) {
//                .
                date=StrUtil.isEmpty(date)?"": DateUtil.offsetDay(DateUtil.parse(date),-1).toString("yyyy/MM/dd");
                map=xhcn(rel,cn.getKw(),cn.getGx(),1, date);
                date=map.get("jgsj");
                l.setQgrq(date);
                l.setQgsb(map.get("sbbh"));
                l.setQggxbm(cn.getGx());
            }
            // 坡口
            if (ObjectUtil.isNotEmpty(l.getPkcd()) && ("08,10".indexOf(cn.getGx()) > 0)) {
                map=xhcn(rel,cn.getKw(),cn.getGx(),1, date);
                date=map.get("jgsj");
                l.setPkrq(date);
                l.setPksb(map.get("sbbh"));
                l.setPkgxbm(cn.getGx());
            }
            // 打磨
            if (ObjectUtil.isNotEmpty(l.getDmcd()) && ("16,13".indexOf(cn.getGx()) > 0)) {
                map=xhcn(rel,cn.getKw(),cn.getGx(),1, date);
                date=map.get("jgsj");
                l.setDmrq(date);
                l.setDmsb(map.get("sbbh"));
                l.setDmgxbm(cn.getGx());
            }
            // 曲 （个）
            if (StrUtil.isNotEmpty(l.getQbs()) && cn.getGx().equals("18")) {
                map=xhcn(rel,cn.getKw(),cn.getGx(),1, date);
                date=map.get("jgsj");
                l.setQjgrq(date);
                l.setQsb(map.get("sbbh"));
                l.setQjggxbm(cn.getGx());
            }

            // 号料 手工切割 倒棱 切端头 自由边 预组
        }
    }

    /**
     *  消耗产能
     * @param rel 实际产能,默认未来三个月
     * @param kw 跨位
     * @param gx 工序
     * @param gzl 工作量
     * @param kssj 上一道工序的加工时间
     * @return
     */
    public  Map xhcn(Map<String,Map<String,List<RealCapacity>>> rel,String kw,String gx,double gzl ,String kssj){
        Map<String,String> map=new TreeMap<>();
        map.put("jgsj","");
        map.put("sbbh","");
        if (gzl==0)return map;
        String kwAndGx=kw+gx;
        for (String date:rel.keySet()){
            if (StrUtil.isEmpty(kssj)||date.compareTo(kssj)>0){
                //日期下 跨位+工序分组
                Map<String,List<RealCapacity>> kwMap= rel.get(date);
                if (ObjectUtil.isEmpty(kwMap.get(kwAndGx)))break;
                for (RealCapacity l : kwMap.get(kwAndGx)) {
                    if (l.getCapacity()>=gzl){
                        int index = rel.get(date).get(kwAndGx).indexOf(l);
                        l.setCapacity(l.getCapacity()-gzl);
                        rel.get(date).get(kwAndGx).set(index,l);
                        map.put("jgsj",l.getDate());
                        map.put("sbbh",l.getDeviceName());
                        return map;
                    }else if (l.getCapacity()!=0.0){
                        gzl=gzl-l.getCapacity();
                        l.setCapacity(new Double(0.0));
                        int index = rel.get(date).get(kwAndGx).indexOf(l);
                        rel.get(date).get(kwAndGx).set(index,l);
                        map.put("jgsj",l.getDate());
                        map.put("sbbh",l.getDeviceName());
                    }
                }
            }

        }
        return map;

    }

    public void ypc_old(List<DmSygdMx> list) {
        Map<String, List<DmSygdMx>> mxMap = list.stream().collect(Collectors.groupingBy(x -> x.getKw() + x.getZl()));
        //加工工序list
        List<EmSbcnp> sbcnp = sbcnpService.list(new QueryWrapper<EmSbcnp>().orderByDesc("tzbh,zl,jgsx"));
        Map<String, List<EmSbcnp>> cnMap = sbcnp.stream().collect(Collectors.groupingBy(l -> l.getTzbh() + l.getZl()));


        for (String ljkey : mxMap.keySet()) {
            List<EmSbcnp> jgsx= cnMap.get(ljkey);
            for (String cnkey : cnMap.keySet()) {
                if (ljkey.equals(cnkey)) {
                    List<DmSygdMx> mxs = mxMap.get(ljkey);
                    List<EmSbcnp> cns = cnMap.get(cnkey);
                    //*******
                    mxs.forEach(l -> {
                        double ljgs = 0.0;
                        AtomicBoolean slflag =new AtomicBoolean(true),pwflag=new AtomicBoolean(true);
                        for (EmSbcnp cn : cns) {
                            // 号料 手工切割 倒棱 切端头 自由边 预组
                            // 曲 （个）
                            if (StrUtil.isNotEmpty(l.getQbs()) && cn.getGx().equals("18")) {
                                ljgs += l.getLjsl() / cn.getDegs();
                                l.setQjgrq(getRq(ljgs, l.getJssj()));
                            }

                            // 打磨
                            if (ObjectUtil.isNotEmpty(l.getDmcd()) && ("16,13".indexOf(cn.getGx()) > 0)) {
                                ljgs += l.getDmcd() / cn.getDegs();
                                l.setDmrq(getRq(ljgs, l.getJssj()));
                            }

                            // 坡口
                            if (ObjectUtil.isNotEmpty(l.getPkcd()) && ("08,10".indexOf(cn.getGx()) > 0)) {
                                ljgs += l.getPkcd() / cn.getDegs();
                                l.setPkrq(getRq(ljgs, l.getJssj()));
                            }

                            if ("03,04,05,06,07".indexOf(cn.getGx()) > -1) {
                                ljgs += l.getQgcd() / cn.getDegs();
                                l.setQgrq(getRq(ljgs, l.getJssj()));
                            }
                            // 划线
                            if ("01,02".indexOf(cn.getGx()) > -1) {
                                ljgs += l.getHxcd() / cn.getDegs();
                                l.setHxrq(getRq(ljgs, l.getJssj()));
                            }
                            //上料
                            if (cn.getGx().equals("19")) {
                                ljgs += l.getHxcd() / cn.getDegs();
                                l.setSlrq(getRq(ljgs, l.getJssj()));
                                slflag.set(false);
                            }
                            //抛丸
                            if (cn.getGx().equals("20")) {
                                ljgs += l.getHxcd() / cn.getDegs();
                                l.setPwrq(getRq(ljgs, l.getJssj()));
                                pwflag.set(false);
                            }
                            //理料
                            if (cn.getGx().equals("21")) {
                                ljgs += l.getHxcd() / cn.getDegs();
                                l.setLlrq(getRq(ljgs, l.getJssj()));
                            }
                        }
                        //当对应工序产能不存在时,按照文档日期计算规则设置默认计划期
                        if (pwflag.get()&&StrUtil.isNotEmpty(l.getQgrq())){
                            l.setPwrq(DateUtil.offsetDay(DateUtil.parse(l.getQgrq(),"yyyy/MM/dd"),-2).toString("yyyy/MM/dd"));
                        }

                        if (slflag.get()&&StrUtil.isNotEmpty(l.getPwrq())){
                            l.setSlrq(DateUtil.offsetDay(DateUtil.parse(l.getPwrq(),"yyyy/MM/dd"),-2).toString("yyyy/MM/dd"));
                        }

                        this.save(l);
                    });

                }
            }
        }
    }
    public String getRq(Double gs, String rq) {
        double ts = gs / 8;
        int num = (int) ts;
        num += (ts - num) > 0 ? 1 : 0;
        return DateUtil.format(DateUtil.offsetDay(DateUtil.parseDate(rq), -num), "yyyy/MM/dd");
    }


    /**
     * 提取线表信息
     *
     * @param list
     * @return
     */
    @Override
    public List<Xbjhdto> getXBList(List<DmSygdMx> list, String year, String begin, String end) {
        //
        //线表 年月 船号 重量
        //批量表重量 中日程重量
        //明细 按船号 月份 分组 计算重量 排产重量

        List<DmXbjh> xbjhs = xbService.list(new QueryWrapper<DmXbjh>()
                .eq("nf", year)
                .ne("zl", 0)
                .between("yf", begin, end));
        List<Xbjhdto> xbjhdtos = BeanUtil.copyToList(xbjhs, Xbjhdto.class);

        //3.根据月份和船号分组
        Map<String, List<DmSygdMx>> monthAndCh = list.stream()
                .filter(mx -> Objects.nonNull(mx.getJssj())) // group by 的字段不能有null值
                .collect(Collectors.groupingBy(x -> x.getJssj().substring(5, 7) + x.getDcCh()));

        //4.
        xbjhdtos.forEach(dmXbjh -> {
            for (String ch : monthAndCh.keySet()) {
                if (dmXbjh.getDcCh().equals(monthAndCh.get(ch).get(0).getDcCh())
                        && dmXbjh.getYf().equals(monthAndCh.get(ch).get(0).getJssj().substring(5, 7))) {
                    Double shzl = 0.0;
                    for (DmSygdMx mx : monthAndCh.get(ch)) {
                        shzl = shzl + (Objects.isNull(mx.getBcshzl()) ? 0.0 : mx.getBcshzl());
                    }
                    shzl = Double.valueOf(String.format("%.2f", Objects.isNull(shzl) ? shzl : shzl / 1000.0));
                    dmXbjh.setTlt_zl(shzl);
                    dmXbjh.setXczl(Double.valueOf(String.format("%.2f", shzl - dmXbjh.getZl())));
                    dmXbjh.setMxList(monthAndCh.get(ch));
                } else {
                    dmXbjh.setXczl(Double.valueOf(String.format("%.2f", 0.0 - dmXbjh.getZl())));
                }
            }
        });
        List<Xbjhdto> xbjhdtoList=new ArrayList<>(xbjhdtos);
        for (String ch : monthAndCh.keySet()) {
            Xbjhdto dmXbjh=new Xbjhdto();
            for (Xbjhdto xbjhdto : xbjhdtos) {
                if (!(xbjhdto.getDcCh().equals(monthAndCh.get(ch).get(0).getDcCh())
                        && xbjhdto.getYf().equals(monthAndCh.get(ch).get(0).getJssj().substring(5, 7)))) {
                    Double shzl = 0.0;
                    for (DmSygdMx mx : monthAndCh.get(ch)) {
                        shzl = shzl + (Objects.isNull(mx.getBcshzl()) ? 0.0 : mx.getBcshzl());
                    }
                    shzl = Double.valueOf(String.format("%.2f", Objects.isNull(shzl) ? shzl : shzl / 1000.0));
                    dmXbjh.setTlt_zl(shzl);
                    dmXbjh.setXczl(Double.valueOf(String.format("%.2f", shzl - dmXbjh.getZl())));
                    dmXbjh.setMxList(monthAndCh.get(ch));
                    dmXbjh.setDcCh(monthAndCh.get(ch).get(0).getDcCh());
                    dmXbjh.setYf(monthAndCh.get(ch).get(0).getJssj().substring(5, 7));
                    dmXbjh.setNf(monthAndCh.get(ch).get(0).getJssj().substring(0, 4));//2024/04/05

                }
            }
            if (dmXbjh.getTlt_zl()>0){
                xbjhdtoList.add(dmXbjh);
            }

        }
        Map<String, List<Xbjhdto>> yf = xbjhdtoList.stream()
                .filter(mx -> Objects.nonNull(mx.getDcCh())) // group by 的字段不能有null值
                .collect(Collectors.groupingBy(x -> x.getYf()));
        List<Xbjhdto> list1 = new ArrayList<>();

        for (String month : yf.keySet()) {
            Double tlt_zl = 0.0;
            Double zl = 0.0;
            List<Xbjhdto> y = yf.get(month);
            for (Xbjhdto l : y) {
                tlt_zl = tlt_zl + l.getTlt_zl();
                zl = zl + l.getZl();
            }
            list1.addAll(yf.get(month));
            Xbjhdto xbjhdto = new Xbjhdto();
            xbjhdto.setDcCh("合计");
            xbjhdto.setXczl(Double.valueOf(String.format("%.2f", tlt_zl - zl)));
            xbjhdto.setTlt_zl(Double.valueOf(String.format("%.2f", tlt_zl)));
            xbjhdto.setZl(Double.valueOf(String.format("%.2f", zl)));
            xbjhdto.setYf(month);
            xbjhdto.setNf(y.get(0).getNf());
            list1.add(xbjhdto);
        }
        list1 = list1.stream()
                .sorted(Comparator.comparing(Xbjhdto::getYf)).collect(Collectors.toList());
        return list1;
    }

    /**
     * 提取批量表信息
     *
     * @return
     */
    @Override
    public List<Pldto> getPl(String begin, String end) {
        DmSygdMxLj one = ljService.getOne(new QueryWrapper<DmSygdMxLj>()
                .select("top 1 xzglxq ")
                .inSql("parent_id ", " SELECT dm_sygd_mx.id from dm_sygd_mx WHERE dm_sygd_mx.jssj BETWEEN '" + begin + "' and '" + end + "'")
                .orderByAsc("xzglxq"));

        DmSygdMxLj two = ljService.getOne(new QueryWrapper<DmSygdMxLj>()
                .select("top 1 xzglxq ")
                .inSql("parent_id ", " SELECT dm_sygd_mx.id from dm_sygd_mx WHERE dm_sygd_mx.jssj BETWEEN '" + begin + "' and '" + end + "'")
                .orderByDesc("xzglxq"));
        if (ObjectUtil.isAllNotEmpty(one,two)){
            List<Pldto> pldtoList = baseMapper.getPl(one.getXzglxq(), two.getXzglxq());
            return pldtoList;
        }
        return null;
    }

    /**
     * 提取跨位信息
     *
     * @param
     * @return
     */
    @Override
    public List<Kwdto> getKwList(List<DmSygdMx> list, String begin, String end) {
        List<Kwdto> kwdtoList = baseMapper.getkw(begin, end);

        kwdtoList.forEach(l -> {
            l.setMxList(list.stream().filter(
                    m -> m.getDcCh().equals(l.getCh())
                            && m.getDcPl().equals(l.getPl())
                            && (StrUtil.hasEmpty(m.getKw(), l.getKw()) ? true : m.getKw().equals(l.getKw()))
                            && m.getJssj().substring(0, 7).equals(l.getYf())
            ).collect(Collectors.toList()));

        });
        Map<String, List<Kwdto>> map = kwdtoList.stream().collect(Collectors.groupingBy(Kwdto::getYf));
        List<Kwdto> kws = new ArrayList<>();
        for (String yf : map.keySet()) {
            int count = list.stream().filter(
                    m -> m.getJssj().substring(0, 7).equals(yf)
            ).collect(Collectors.toList()).size();
            Kwdto k = new Kwdto();
            k.setYf(yf.substring(5, 7) + "月份合计");
            k.setBs(new BigDecimal(count));
            kws.add(k);
            kws.addAll(map.get(yf));
        }
        return kws;
    }

    public List<Kwdto> getKwList_n(List<DmSygdMx> list) {
        //1.将明细信息，按照跨位分组
        Map<String, List<DmSygdMx>> map = list.stream().collect(Collectors.groupingBy(x -> Optional.ofNullable(x.getKw()).orElse("")));
        List<Kwdto> kwdtoList = new ArrayList<>();
        //2.按照日期，统计每个跨位信息
        for (String kw : map.keySet()) {
            //TODO 根据上料日期分组
            Map<String, List<DmSygdMx>> map1 = map.get(kw).stream().collect(Collectors.groupingBy(x -> Optional.ofNullable(x.getSlrq()).orElse("无法")));
            for (String rq : map1.keySet()) {
                Kwdto kwdto = new Kwdto();
//                kwdto.setRq(rq);
                kwdto.setKw(kw);
                List<DmSygdMx> list1 = map1.get(rq);
//                kwdto.setTlt_sl(list1.size());
                BigDecimal hx_cd = new BigDecimal(0);
                BigDecimal qg_cd = new BigDecimal(0);
                for (DmSygdMx mx : list1) {
                    hx_cd = hx_cd.add(ObjectUtil.isEmpty(mx.getHxcd()) ? new BigDecimal(0) : new BigDecimal(mx.getHxcd()));
                    qg_cd = qg_cd.add(ObjectUtil.isEmpty(mx.getQgcd()) ? new BigDecimal(0) : new BigDecimal(mx.getQgcd()));
                }
//                kwdto.setHx_cd(hx_cd);
//                kwdto.setQg_cd(qg_cd);
                kwdto.setMxList(list1);
                kwdtoList.add(kwdto);
            }
        }
//        kwdtoList = kwdtoList.stream().sorted(Comparator.comparing(Kwdto::getRq, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
        return kwdtoList;
    }

    /**
     * 提取图纸信息
     *
     * @param list
     * @return
     */
    @Override
    public List<Tzjhdto> getTZList(List<DmSygdMx> list) {
        //图纸计划 dmTzjh 船号 批量
        List<Tzjhdto> tzjhdtos = new ArrayList<>();
        Map<String, List<DmSygdMx>> map = list.stream().collect(Collectors.groupingBy(mx -> mx.getDcCh() + mx.getDcPl()));
        for (String key : map.keySet()) {
            List<DmSygdMx> list1 = map.get(key).stream().sorted(Comparator.comparing(DmSygdMx::getSlrq, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
            DmTzjh tzjh = tzjhService.getOne(new QueryWrapper<DmTzjh>()
                    .select("DC_CH,DC_PL,xfq_lqb,jsq_lqb,xfq_tlt,jsq_tlt,stuff( ( SELECT ' ' + c.DC_FD FROM dm_tzjh c  WHERE c.DC_CH=dm_tzjh.DC_CH and c.DC_PL=dm_tzjh.DC_PL FOR xml path ( '' ) ), 1, 1, '' ) AS dcFd")
                    .eq("DC_CH", list1.get(0).getDcCh())
                    .eq("DC_PL", list1.get(0).getDcPl())
                    .groupBy("DC_CH,DC_PL,xfq_lqb,jsq_lqb,xfq_tlt,jsq_tlt"));
            if (ObjectUtil.isNotEmpty(tzjh)) {
                Tzjhdto tzjhdto = new Tzjhdto();
                BeanUtils.copyProperties(tzjh, tzjhdto);
                tzjhdto.setTzxqq(list1.get(0).getSlrq());//todo 使用上料日期作为需求期
                tzjhdto.setMxList(list1);
                tzjhdtos.add(tzjhdto);
            }
        }
        tzjhdtos = tzjhdtos.stream().sorted(Comparator.comparing(Tzjhdto::getTzxqq, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
        return tzjhdtos;
    }

    /**
     * 提取到货信息
     *
     * @param list
     * @return
     */
    @Override
    public List<Dhdto> getDhList(List<DmSygdMx> list) {
        //船号 批量 订单号
//        Map<String, List<DmSygdMx>> map = list.stream()
//                .filter(mx -> Objects.nonNull(mx.getDhqd()))
//                .collect(Collectors.groupingBy(mx -> mx.getDcCh() + mx.getDcPl() + mx.getDhqd()));
//
        List<Dhdto> list1 = new ArrayList<>();
//        for (String key : map.keySet()) {
//            for (DmSygdMx mx : map.get(key)) {
//                Dhdto dhdto = new Dhdto();
//                List<DmSygdMx> mxs = new ArrayList<>();
//                dhdto.setDcCh(mx.getDcCh());
//                dhdto.setDcPl(mx.getDcPl());
//                dhdto.setDhqd(mx.getDhqd());
//                String[] str = mx.getWpgg().split("\\*");
//                dhdto.setWphd(str[0]);
//                dhdto.setWpkd(str[1]);
//                dhdto.setWpcd(str[2]);
//                dhdto.setRkxh(mx.getWpxh());
//                dhdto.setGcxqq(mx.getSlrq());
//                dhdto = baseMapper.getDhsl(dhdto);
//                mxs.add(mx);
//                dhdto.setMxList(mxs);
//                list1.add(dhdto);
//            }
//        }
        //以list为主
        return list1;
    }

    /**
     * 生成3月滚动计划
     *
     * @return
     */
    @Transactional
    public ResultBean tqSygd(String begin, String end) {
        //1.查询未来3个月明细信息
        //测试
//        List<DmSygdMx> list=null;
//        String begin = DateUtil.format(DateUtil.nextMonth(), "yyyy/MM/01");
//        String end = DateUtil.format(DateUtil.endOfMonth(DateUtil.offsetMonth(DateUtil.date(), 3)), "yyyy/MM/dd");

        List<DmSygdMx> list = this.list(new QueryWrapper<DmSygdMx>()
                .between("jssj",
                        begin,
                        end)
                .orderByAsc("jssj")
        );
        if (ObjectUtil.isEmpty(list) || list.size() < 1) {
            return new ResultBean(null);
        }
        //根据船号+批量分组
        Map<String, List<DmSygdMx>> map = list.stream().filter(mx -> Objects.nonNull(mx.getTzbh())) // group by 的字段不能有null值
                                                         .collect(Collectors.groupingBy(x -> x.getDcCh() + x.getDcPl()));
        List<DmSygd> sygdList = new ArrayList<>();
        for (String key : map.keySet()) {
            DmSygd sygd = new DmSygd();
            List<DmSygdMx> mxList = map.get(key);
            sygd.setDcCh(mxList.get(0).getDcCh());
            sygd.setDcPl(mxList.get(0).getDcPl());
            sygd.setDcFd(mxList.get(0).getDcFd());
            sygd.setTltSl(mxList.size());
            sygd.setSlSj(mxList.get(0).getSlrq());
            sygd.setSlSl(mxList.size());
            sygd.setPwSj(mxList.get(0).getSlrq());
            sygd.setPwSl(mxList.size());
            sygd.setGjjsDz(mxList.get(0).getGjjsDz());
            sygd.setGjjsXz(mxList.get(0).getJssj());
            //跨位信息
            Map<String, List<DmSygdMx>> kwMap = map.get(key).stream().collect(Collectors.groupingBy(x -> Optional.ofNullable(x.getKw()).orElse("0")));
            for (String kw : kwMap.keySet()) {
                //组立信息
                Map<String, List<DmSygdMx>> zlMap = kwMap.get(kw).stream().collect(Collectors.groupingBy(x -> Optional.ofNullable(x.getZl()).orElse("0")));
                for (String zl : zlMap.keySet()) {
                    //跨位、组立下，多张套料图的最开始加工时间，最后加工时间；（上料日期）
                    List<DmSygdMx> kssj = zlMap.get(zl).stream().sorted(Comparator.comparing(DmSygdMx::getSlrq, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
//                    List<DmSygdMx> jssj = zlMap.get(zl).stream().sorted(Comparator.comparing(DmSygdMx::getSlrq, Comparator.nullsLast(Comparator.naturalOrder())).reversed()).collect(Collectors.toList());

                    String sj = kssj.get(0).getSlrq();

                    if (kw.equals("7")) {//1跨平直大板
                        if (zl.equals("1110")) {//大组
                            sygd.setN1ad(kssj.size());
                            sygd.setN1adSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN1ax(kssj.size());
                            sygd.setN1axSj(sj);
                        }
                    }
                    if (kw.equals("8")) {//1跨进线板
                        sygd.setN1ld(kssj.size());
                        sygd.setN1ldSj(sj);
                    }
                    if (kw.equals("5")) {//2跨T型材面板
                        if (zl.equals("1110")) {//大组
                            sygd.setS2td(kssj.size());
                            sygd.setS2tdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setS2tx(kssj.size());
                            sygd.setS2txSj(sj);
                        }

                    }
                    if (kw.equals("9")) {//2跨超长超宽板
                        if (zl.equals("1110")) {//大组
                            sygd.setN2bd(kssj.size());
                            sygd.setN2bdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN2bx(kssj.size());
                            sygd.setN2bxSj(sj);
                        }
                    }
                    if (kw.equals("10")) {//2跨超长超宽曲板
                        if (zl.equals("1110")) {//大组
                            sygd.setN2cd(kssj.size());
                            sygd.setN2cdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN2cx(kssj.size());
                            sygd.setN2cxSj(sj);
                        }
                    }
                    if (kw.equals("11")) {//2跨T型材腹板
                        if (zl.equals("1110")) {//大组
                            sygd.setN2td(kssj.size());
                            sygd.setN2tdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN2tx(kssj.size());
                            sygd.setN2txSj(sj);
                        }
                    }
                    if (kw.equals("12")) {//2跨激光切割板
                        if (zl.equals("1110")) {//大组
                            sygd.setN2jd(kssj.size());
                            sygd.setN2jdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN2jx(kssj.size());
                            sygd.setN2jxSj(sj);
                        }

                    }
                    if (kw.equals("14")) {//3跨厚板
                        if (zl.equals("1110")) {//大组
                            sygd.setN3hd(kssj.size());
                            sygd.setN3hdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN3hx(kssj.size());
                            sygd.setN3hxSj(sj);
                        }

                    }
                    if (kw.equals("6")) {//3跨平铁
                        if (zl.equals("1110")) {//大组
                            sygd.setS3pd(kssj.size());
                            sygd.setS3pdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setS3px(kssj.size());
                            sygd.setS3pxSj(sj);
                        }
                        if (zl.equals("4230")) {//焊接机器人肘板
                            sygd.setS3xx(kssj.size());
                            sygd.setS3xxSj(sj);
                        }

                    }
                    if (kw.equals("13")) {//3跨曲板
                        if (zl.equals("1110")) {//大组
                            sygd.setN3cd(kssj.size());
                            sygd.setN3cdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN3cx(kssj.size());
                            sygd.setN3cxSj(sj);
                        }
                    }
                    if (kw.equals("15")) {//4跨普通板
                        if (zl.equals("1110")) {//大组
                            sygd.setN4pd(kssj.size());
                            sygd.setN4pdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN4px(kssj.size());
                            sygd.setN4pxSj(sj);
                        }
                        if (zl.equals("4230")) {//焊接机器人肘板
                            sygd.setN4xx(kssj.size());
                            sygd.setN4xxSj(sj);
                        }

                    }
                    if (kw.equals("16")) {//7跨型板
                        if (zl.equals("1110")) {//大组
                            //todo 型材米数
                            sygd.setX7xd(kssj.size());
                            sygd.setX7xdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setX7xx(kssj.size());
                            sygd.setX7xxSj(sj);
                        }
                    }
                    if (kw.equals("17")) {//光电
                        sygd.setN8gx(kssj.size());
                        sygd.setN8gxSj(sj);
                    }
                }
                //1跨 板数 加工 时间
                //1跨 板数 加工 时间
            }
            sygdService.remove(new QueryWrapper<DmSygd>().eq("DC_CH", sygd.getDcCh()).eq("DC_PL", sygd.getDcPl()));
            sygdList.add(sygd);
        }
        sygdList = sygdList.stream().sorted(Comparator.comparing(DmSygd::getDcCh).thenComparing(DmSygd::getDcPl)).collect(Collectors.toList());
        sygdService.saveBatch(sygdList);
        return new ResultBean(sygdList);
    }

    public List<DmYdjhxf> tqSygd2(String begin,String end,String zt){
        List<DmSygdMx> list = this.list(Wrappers.<DmSygdMx>lambdaQuery()
                        .eq(StrUtil.isNotEmpty(zt),DmSygdMx::getZt,zt)
                .between(DmSygdMx::getJssj, begin, end)
                .orderByAsc(DmSygdMx::getSlrq)
        );
        //合并曲外板项
        Map<String, List<DmSygdMx>> collectQ = list.stream().filter(item->"1".equals(item.getQbs())).collect(Collectors.groupingBy(item -> item.getDcCh() +"_"+ item.getDcPl()));
        List<DmYdjhxf> qList = this.handler(collectQ,true);
        qList=qList.stream().sorted(Comparator.comparing(item->item.getDcCh()+item.getDcPl())).collect(Collectors.toList());
        //合并非曲外板项
        Map<String, List<DmSygdMx>> collect = list.stream().filter(item->!"1".equals(item.getQbs())).collect(Collectors.groupingBy(item -> item.getDcCh() +"_"+ item.getDcPl()));
        List<DmYdjhxf> list2 = this.handler(collect,false);

        list2=list2.stream().sorted(Comparator.comparing(item->item.getDcCh()+item.getDcPl())).collect(Collectors.toList());
        qList.addAll(list2);
        return qList;
    }

    private List<DmYdjhxf> handler(Map<String, List<DmSygdMx>> collect,boolean qflag){
        List<String> slkw=Arrays.asList("7","8","9","5","6","15","11","14");
        List<DmYdjhxf> list2=new ArrayList<>();
        //按批次合并为一行
        collect.forEach((key,val)->{
            List<String> tzbhList=new ArrayList<>();
            Set<String> plSet=new HashSet<>();
            DmYdjhxf dmYdjhxf = new DmYdjhxf();
            dmYdjhxf.setDcCh(key.split("_")[0]);
            dmYdjhxf.setDcPl(key.split("_")[1]);
            if (qflag){
                dmYdjhxf.setDcPl(dmYdjhxf.getDcPl()+"Q");
            }

            AtomicReference<Integer> bs= new AtomicReference<>(0);
            AtomicReference<Integer> yklm= new AtomicReference<>(0);
            AtomicReference<Integer> yksk= new AtomicReference<>(0);
            AtomicReference<Integer> eksk= new AtomicReference<>(0);
            AtomicReference<Integer> eksk2= new AtomicReference<>(0);
            AtomicReference<Integer> sksk= new AtomicReference<>(0);
            AtomicReference<Integer> skpt= new AtomicReference<>(0);
            AtomicReference<Integer> skbs= new AtomicReference<>(0);
            AtomicReference<Integer> skbs2= new AtomicReference<>(0);
            val.forEach(item-> {
                if (tzbhList.contains(item.getTzbh())){
                    return;
                }
                tzbhList.add(item.getTzbh());
                plSet.add(item.getDcFd());

                if (slkw.contains(item.getKw())){
                    bs.updateAndGet(v -> v + 1);
                }
                if ("7".equals(item.getKw())){
                    yklm.updateAndGet(v -> v + 1);
                }
                if ("8".equals(item.getKw())){
                    yksk.updateAndGet(v -> v + 1);
                }
                if ("9".equals(item.getKw())){
                    eksk.updateAndGet(v -> v + 1);
                }
                if ("5".equals(item.getKw())){
                    eksk2.updateAndGet(v -> v + 1);
                }

                if ("14".equals(item.getKw())){
                    sksk.updateAndGet(v -> v + 1);
                }
                if ("6".equals(item.getKw())){
                    skpt.updateAndGet(v -> v + 1);
                }
                if ("15".equals(item.getKw())){
                    skbs.updateAndGet(v -> v + 1);
                }
                if ("11".equals(item.getKw())){
                    skbs2.updateAndGet(v -> v + 1);
                }
            });
            dmYdjhxf.setDcFd(String.join("/", plSet));
            dmYdjhxf.setBs(Double.valueOf(bs.get()));

            //上料日期
            val.stream().filter(item->StrUtil.isNotEmpty(item.getSlrq()))
                    .min(Comparator.comparing(DmSygdMx::getSlrq)).ifPresent(item->dmYdjhxf.setSl(item.getSlrq()));

            //型材抛丸日期
            val.stream().filter(item -> "16".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getXcpw()))
                    .min(Comparator.comparing(DmSygdMx::getXcpw)).ifPresent(item -> dmYdjhxf.setXcpw(item.getXcpw()));

            //抛丸日期
            val.stream().filter(item->StrUtil.isNotEmpty(item.getPwrq()))
                    .min(Comparator.comparing(DmSygdMx::getPwrq)).ifPresent(item -> dmYdjhxf.setPw(item.getPwrq()));


            val.stream().filter(item->StrUtil.isNotEmpty(item.getGdjs()))
                    .min(Comparator.comparing(DmSygdMx::getPwrq)).ifPresent(item -> dmYdjhxf.setGdjs(item.getGdjs()));

            //一跨龙门数量
            dmYdjhxf.setYklm(yklm.get()+"");
            //一跨数控数量
            dmYdjhxf.setYksk(yksk.get()+"");
            //二跨数控数量
            dmYdjhxf.setEksk(eksk.get()+"");

            //二跨数控开始
            val.stream().filter(item -> "9".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQgrq()))
                    .min(Comparator.comparing(DmSygdMx::getQgrq)).ifPresent(item -> dmYdjhxf.setEkskks(item.getQgrq()));

            //二跨数控2
            dmYdjhxf.setEksk2(eksk2.get()+"");
            //二跨数控2开始
            val.stream().filter(item -> "5".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQgrq()))
                    .min(Comparator.comparing(DmSygdMx::getQgrq)).ifPresent(item -> dmYdjhxf.setEkskks(item.getQgrq()));

            dmYdjhxf.setSksk(sksk.get()+"");
            val.stream().filter(item->"14".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQgrq()))
                    .min(Comparator.comparing(DmSygdMx::getQgrq)).ifPresent(item -> dmYdjhxf.setSkskqgks(item.getQgrq()));
            val.stream().filter(item->"14".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQgjs()))
                    .min(Comparator.comparing(DmSygdMx::getQgjs)).ifPresent(item -> dmYdjhxf.setSkpkjs(item.getQgjs()));

            dmYdjhxf.setSkpt(skpt.get()+"");
            val.stream().filter(item -> "6".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQgrq()))
                    .min(Comparator.comparing(DmSygdMx::getQgrq)).ifPresent(item -> dmYdjhxf.setPtks(item.getQgrq()));

            val.stream().filter(item -> "6".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQjgrq()))
                    .min(Comparator.comparing(DmSygdMx::getQjgrq)).ifPresent(item -> dmYdjhxf.setPtjs(item.getQjgrq()));

            dmYdjhxf.setSkbs(skbs.get()+"");
            val.stream().filter(item->"15".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQgrq()))
                    .min(Comparator.comparing(DmSygdMx::getQgrq)).ifPresent(item -> dmYdjhxf.setSkqgks(item.getQgrq()));

            dmYdjhxf.setSkbs2(skbs2.get()+"");
            val.stream().filter(item->"11".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQgrq()))
                    .min(Comparator.comparing(DmSygdMx::getQgrq)).ifPresent(item -> dmYdjhxf.setSkbs2(item.getQgrq()));

            val.stream().filter(item->"7".equals(item.getKw()))
                    .filter(item->StrUtil.isNotEmpty(item.getQgrq()))
                    .min(Comparator.comparing(DmSygdMx::getQgrq)).ifPresent(item -> dmYdjhxf.setYkpkjs(item.getQgrq()));

            dmYdjhxf.setFdxq(val.get(0).getJssj());
            list2.add(dmYdjhxf);
        });
        return list2;
    }

    @Transactional
    public List<DmYdjhxf> tqSygd1(String begin,String end){

//        List<DmYdjhxf> list=  baseMapper.tqSygd1(begin,end);
//        List<DmYdjhxf> list2=new ArrayList<>();

        //1行分为两行
//        for (DmYdjhxf l : list) {
//            DmYdjhxf ydjhxf1=new DmYdjhxf();//第二行
//            ydjhxf1.setDcCh(l.getDcCh());
//            ydjhxf1.setDcPl(l.getDcPl());
//            String[] fds= l.getDcFd().split(" ");
//            double count= fds.length%2;
//            int index;
//            if (count>0){
//                index= (fds.length/2)+1;
//            }else {
//                index= fds.length/2;
//            }
//            String fd1= Arrays.toString(Arrays.copyOfRange(fds, 0, index)).replace(","," ");// 截取索引0（包括）到索引index（不包括）的元素
//            String fd2= Arrays.toString(Arrays.copyOfRange(fds, index, fds.length)).replace(","," ");
//
//            l.setDcFd(fd1.substring(1,fd1.lastIndexOf("]")));
//            ydjhxf1.setDcFd(fd2.substring(1,fd2.lastIndexOf("]")));
//            ydjhxf1.setEksk(l.getEksk2());
//            ydjhxf1.setEkskks(l.getEkskks2());
//            if (StrUtil.isNotEmpty(l.getSkbs())){
//                l.setZl("X");//4跨普通板
//            }
//            if (StrUtil.isNotEmpty(l.getSkbs2())){
//                ydjhxf1.setZl("Z");//2跨T型材腹板
//            }
//            ydjhxf1.setSkbs(l.getSkbs2());
//            ydjhxf1.setSkqgks(l.getSkqgks2());
//            ydjhxf1.setFdxq(l.getFdxq());
//            list2.add(l);
//            list2.add(ydjhxf1);
//        }

      return this.tqSygd2(begin,end,null);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void ydjhImport(List<JhxfExcel> objList) {
        // 1,同产品与批量视为一条记录  dcch  dcpl
        // 2,板数是否为空  不为空循环板数增加记录(还有一个其他集合)  bs1=7
        //3,后续数量中  bs2=2 bs3=5      其中两条rq='2024/10/25'  另外五条rq='2024/10/23'
        String dcch="";
        String dcpl="";

        int zz=0;
        int num=0;
        int zsl=0;
        List<DmSygdMx> overlist=new ArrayList<>();
        Map<String,List<DmSygdMx>> map =new HashMap();
        for (int i = 0; i < objList.size(); i++) {
            JhxfExcel jhxfExcel = objList.get(i);


            if(!dcch.equals(jhxfExcel.getDcCh()) || !dcpl.equals(jhxfExcel.getDcPl())){
                //if(StringUtils.isBlank(dcch)){
                    dcch=jhxfExcel.getDcCh();
                //}
            //    if(StringUtils.isBlank(dcpl)){
                    dcpl=StrUtil.padPre(jhxfExcel.getDcPl(),3,"0");
                num=0;
                zsl=0;
                zz=0;
              //  }
                //进行循环
                String bs1 = jhxfExcel.getBs1();
              //  int num=0;
                if(StringUtils.isNotBlank(bs1)){
                    num= MyString.convertStringToNumber(bs1);
                }
                List<DmSygdMx> insertsOne= new ArrayList<>();
                if(num>0){

                    for (int j = 0; j < num; j++) {
                        // 生成数据
                        DmSygdMx sygdMx= new DmSygdMx();
                        sygdMx.setDcCh(jhxfExcel.getDcCh());
                        sygdMx.setDcPl(dcpl);
                        sygdMx.setDcFd(jhxfExcel.getDcFd());
                        sygdMx.setSlrq(jhxfExcel.getSl());
                        sygdMx.setPwrq(jhxfExcel.getPw());
                        sygdMx.setZl(jhxfExcel.getZl());
                        sygdMx.setJssj(jhxfExcel.getFdxq());

//                        @ApiModelProperty(value = "面板挤边")
//                        private String mbjb;
//                        @ApiModelProperty(value = "七垮型材米数")
//                        private String qkxcms;
//                        @ApiModelProperty(value = "型材面板")
//                        private String xcmb;
//                        @ApiModelProperty(value = "分段需求/小组配送结束")
//                        private String fdxq;
//                        @ApiModelProperty(value = "光电结束")
//                        private String gdjs;
//                        @ApiModelProperty(value = "备注")
//                        private String bz;
//
//                        private String bzry;
//                        private String bzrq;

                        sygdMx.setMbjb(jhxfExcel.getMbjb());
                        sygdMx.setQkxcms(jhxfExcel.getQkxcms());
                        sygdMx.setXcmb(jhxfExcel.getXcmb());
                        sygdMx.setFdxq(jhxfExcel.getFdxq());
                        sygdMx.setGdjs(jhxfExcel.getGdjs());
                        sygdMx.setBz(jhxfExcel.getBz());

                        insertsOne.add(sygdMx);
                    }
                }else{
                    dcch="";
                    dcpl="";
                    continue;
                }
                int yklm=0;
                if(StringUtils.isNotBlank(jhxfExcel.getYklm())){
                    yklm= MyString.convertStringToNumber(jhxfExcel.getYklm());
                }
                if(yklm>0){
                    zz=yklm;
                    for (int j = 0; j < yklm; j++) {
                        zsl++;
                        if(zsl>num){
                            break;
                        }
                        // 生成数据
                        insertsOne.get(j).setKw("7");
                        insertsOne.get(j).setQgrq(jhxfExcel.getYkpkjs());
                    }
                }

                int yksk=0;
                if(StringUtils.isNotBlank(jhxfExcel.getYksk())){
                    yksk= MyString.convertStringToNumber(jhxfExcel.getYksk());
                }
                if(yksk>0){
                    for (int j = 0; j < yksk; j++) {
                        zsl++;
                        if(zsl>num){
                            break;
                        }
                        // 生成数据
                        insertsOne.get(zz+j).setKw("8");
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getYkpkjs());
                    }
                    zz=zz+yksk;
                }
                int eklmbs=0;
                if(StringUtils.isNotBlank(jhxfExcel.getEklmbs())){
                    eklmbs= MyString.convertStringToNumber(jhxfExcel.getEksk());
                }
                if(eklmbs>0){
                    for (int j = 0; j < eklmbs; j++) {
                        zsl++;
                        if(zsl>num){
                            break;
                        }
                        // 生成数据
                        insertsOne.get(zz+j).setKw("5");
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getLmqgks());
                    }
                    zz=zz+eklmbs;
                }

                int eksk=0;
                if(StringUtils.isNotBlank(jhxfExcel.getEksk())){
                    try {
                        eksk= MyString.convertStringToNumber(jhxfExcel.getEksk());
                    }catch (Exception ignored){}
                }
                if(eksk>0){
                    for (int j = 0; j < eksk; j++) {
                        zsl++;
                        if(zsl>num){
                            break;
                        }
                        // 生成数据
                        insertsOne.get(zz+j).setKw("9");/// 2跨超长超宽曲板 // 2跨T型材腹板  //2跨超长超宽板
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getEkskks());
                    }
                    zz=zz+eksk;
                }
                int sksk=0;
                if(StringUtils.isNotBlank(jhxfExcel.getSksk())){
                    try {
                        sksk= MyString.convertStringToNumber(jhxfExcel.getSksk());
                    }catch (Exception ignored){}
                }
                if(sksk>0){

                    for (int j = 0; j < sksk; j++) {
                        zsl++;
                        if(zsl>num){
                            break;
                        }
                        // 生成数据
                        insertsOne.get(zz+j).setKw("14");///3跨曲板 // 3跨厚板
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getSkskqgks());
                    }
                    zz=zz+sksk;
                }
                int skpt=0;
                if(StringUtils.isNotBlank(jhxfExcel.getSkpt())){
                    try {
                        skpt= MyString.convertStringToNumber(jhxfExcel.getSkpt());
                    }catch (Exception ignored){}
                }
                if(skpt>0){

                    for (int j = 0; j < skpt; j++) {
                        zsl++;
                        if(zsl>num){
                            break;
                        }
                        // 生成数据
                        insertsOne.get(zz+j).setKw("6");///3跨曲板 // 3跨厚板
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getPtks());
                        insertsOne.get(zz+j).setQjgrq(jhxfExcel.getQptjs());
                    }
                    zz=zz+skpt;
                }

                int skbs=0;
                if(StringUtils.isNotBlank(jhxfExcel.getSkbs())){
                    try {
                        skbs= MyString.convertStringToNumber(jhxfExcel.getSkbs());
                    }catch (Exception ignored){}
                }
                if(skbs>0){

                    for (int j = 0; j < skbs; j++) {
                        // 生成数据
                        insertsOne.get(zz+j).setKw("15");///3跨曲板 // 3跨厚板
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getSkqgks());


                        zsl++;
                        if(zsl>num){
                            continue;
                        }
                    }
                    zz=zz+skbs;
                }
                map.put(dcch+"_"+dcpl,insertsOne);

            }else{
                List<DmSygdMx> insertsOne = map.get(dcch +"_"+ dcpl);


                int yklm=0;
                if(StringUtils.isNotBlank(jhxfExcel.getYklm())){
                    try {
                        yklm= MyString.convertStringToNumber(jhxfExcel.getYklm());
                    }catch (Exception ignored){}
                }
                if(yklm>0){
                    zz=yklm;
                    for (int j = 0; j < yklm; j++) {
                        if (j>=insertsOne.size()){
                            break;
                        }
                        // 生成数据
                        insertsOne.get(j).setKw("7");
                        insertsOne.get(j).setQgrq(jhxfExcel.getYkpkjs());
                        zsl++;
                        if(zsl>num){
                            continue;
                        }
                    }
                }

                int yksk=0;
                if(StringUtils.isNotBlank(jhxfExcel.getYksk())){
                    try {
                        yksk= MyString.convertStringToNumber(jhxfExcel.getYksk());
                    }catch (Exception ignored){}
                }
                if(yksk>0){
                    for (int j = 0; j <yksk; j++) {
                        // 生成数据
                        if (j>=insertsOne.size()){
                            break;
                        }
                        insertsOne.get(zz+j).setKw("8");
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getYkpkjs());
                        zsl++;
                        if(zsl>num){
                            continue;
                        }
                    }
                    zz=zz+yksk;
                }
                int eklmbs=0;
                if(StringUtils.isNotBlank(jhxfExcel.getEklmbs())){
                    try {
                        eklmbs= MyString.convertStringToNumber(jhxfExcel.getEksk());
                    }catch (Exception ignored){}
                }
                if(eklmbs>0){
                    for (int j = 0; j < eklmbs; j++) {
                        // 生成数据
                        insertsOne.get(zz+j).setKw("5");
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getLmqgks());
                        zsl++;
                        if(zsl>num){
                            continue;
                        }
                    }
                    zz=zz+eklmbs;
                }

                int eksk=0;
                if(StringUtils.isNotBlank(jhxfExcel.getEksk())){
                    try {
                        eksk= MyString.convertStringToNumber(jhxfExcel.getEksk());
                    }catch (Exception ignored){}
                }
                if(eksk>0){

                    for (int j = 0; j < eksk; j++) {
                        // 生成数据
                        insertsOne.get(zz+j).setKw("9");/// 2跨超长超宽曲板 // 2跨T型材腹板  //2跨超长超宽板
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getEkskks());
                        zsl++;
                        if(zsl>num){
                            continue;
                        }
                    }
                    zz=zz+eksk;
                }
                int sksk=0;
                if(StringUtils.isNotBlank(jhxfExcel.getSksk())){
                    try {
                        sksk= MyString.convertStringToNumber(jhxfExcel.getSksk());
                    }catch (Exception ignored){}
                }
                if(sksk>0){
                    for (int j = 0; j < sksk; j++) {
                        // 生成数据
                        insertsOne.get(zz+j).setKw("14");///3跨曲板 // 3跨厚板
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getSkskqgks());

                        zsl++;
                        if(zsl>num){
                            break;
                        }
                    }
                    zz=zz+sksk;
                }
                int skpt=0;
                if(StringUtils.isNotBlank(jhxfExcel.getSkpt())){
                    try {
                        skpt= MyString.convertStringToNumber(jhxfExcel.getSkpt());
                    }catch (Exception ignored){}
                }
                if(skpt>0){

                    for (int j = 0; j < skpt; j++) {
                        // 生成数据
                        insertsOne.get(zz+j).setKw("6");///3跨曲板 // 3跨厚板
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getPtks());
                        insertsOne.get(zz+j).setQjgrq(jhxfExcel.getQptjs());

                        zsl++;
                        if(zsl>num){
                            continue;
                        }
                    }
                    zz=zz+skpt;
                }

                int skbs=0;
                if(StringUtils.isNotBlank(jhxfExcel.getSkbs())){
                    try {
                        skbs= MyString.convertStringToNumber(jhxfExcel.getSkbs());
                    }catch (Exception ignored){}
                }
                if(skbs>0){
                    for (int j = 0; j < skbs; j++) {
                        // 生成数据
                        insertsOne.get(zz+j).setKw("15");///3跨曲板 // 3跨厚板
                        insertsOne.get(zz+j).setQgrq(jhxfExcel.getSkqgks());

                        zsl++;
                        if(zsl>num){
                            continue;
                        }
                    }
                    zz=zz+skbs;
                }
                map.put(dcch+"_"+dcpl,insertsOne);//这里改为用"_"分割,方便后面逻辑调用
            }
        }

        for (Map.Entry<String, List<DmSygdMx>> entry : map.entrySet()) {
            String key = entry.getKey();
            List<DmSygdMx> value = entry.getValue();

            //todo 支持导入有基础数据的月度计划
            String ch=key.split("_")[0];
            String pl=key.split("_")[1];


            List<DmSygdMx> sygdMxes=this.list(Wrappers.<DmSygdMx>lambdaQuery()
                    .eq(DmSygdMx::getDcCh,ch)
                    .eq(DmSygdMx::getDcPl,pl)
            );

            DmSygdMx importData=value.get(0);
            if (ObjectUtil.isNotEmpty(sygdMxes)){
                CopyOptions options = CopyOptions.create()
                        .setIgnoreNullValue(true)  // 忽略源对象属性为空的情况
                        .setIgnoreError(true);     // 忽略复制过程中出现的错误
                sygdMxes.forEach(item-> BeanUtil.copyProperties(importData, item,options));
                this.updateBatchById(sygdMxes);
            }else {
                List<DmBom> bomList=bomService.list(Wrappers.<DmBom>lambdaQuery().eq(DmBom::getDcch,ch).eq(DmBom::getPl,pl));
                //补充基础数据
                //fixme 这里有个冲突 ,如果导入的数量比bom少,多次导入时无法确认哪些bom被占用
                if (ObjectUtil.isNotEmpty(bomList)){
                    int size=Math.min(value.size(),bomList.size());
                    for (int i=0;i<size;i++){
                        DmSygdMx dmSygdMx = value.get(i);
                        DmBom dmBom = bomList.get(i);
                        dmSygdMx.setBomData(dmBom);
                        dmSygdMx.setId(IdWorker.get32UUID());
                        dmSygdMx.setDrbs("Y");
                    }
                }
                this.saveBatch(value,500);
            }

            // 如果需要，这里还可以进一步遍历List<DmSygdMx>
//            for (DmSygdMx item : value) {
//                // 对每个DmSygdMx对象进行操作
//                System.out.println("DmSygdMx Object: " + item);
//
//                // 简单根据 船号 批量 删除后重复导入
//                this.remove(new QueryWrapper<DmSygdMx>().eq("dc_ch",item.getDcCh()).eq("dc_pl",item.getDcPl())
//                    .eq("dc_fd",item.getDcFd())
//                );
//
//            }
//            for (DmSygdMx item : value) {
//                item.setId(IdWorker.get32UUID());
//                item.setDrbs("Y");
//                this.save(item);
//            }
        }
    }


}
